function [alpha_out,gamma_out]=all_phase_group_ang(s_func,s_der_func,s_par,direction,alpha_in,gamma_in)

% Computes the transformation from phase angles to group angles and respectively
[n_gamma,n_alpha]=size(alpha_in);

% Computation of the PHASE angles from the GROUP angles
if(direction == -1)
  for i_alpha=1:n_alpha
    for i_gamma=1:n_gamma
      % Computation of the group propagation angles
      beta_s_group=alpha_in(i_gamma,i_alpha)-gamma_in(i_gamma,i_alpha);
      beta_r_group=alpha_in(i_gamma,i_alpha)+gamma_in(i_gamma,i_alpha);
      % Computation of the phase propagation angles
      beta_s_phase=phase_group_ang(s_func,s_der_func,s_par,-1,'s',beta_s_group);
      beta_r_phase=phase_group_ang(s_func,s_der_func,s_par,-1,'r',beta_r_group);
      % Computation of the phase reflection and aperture angles
      alpha_out(i_gamma,i_alpha)=.5*(beta_r_phase + beta_s_phase);
      gamma_out(i_gamma,i_alpha)=.5*(beta_r_phase - beta_s_phase);
    end
  end
else
  
% Computation of the GROUP angles from the PHASE angles
  for i_alpha=1:n_alpha
    for i_gamma=1:n_gamma
      % Computation of the phase propagation angles
      beta_s_phase=alpha_in(i_gamma,i_alpha)-gamma_in(i_gamma,i_alpha);
      beta_r_phase=alpha_in(i_gamma,i_alpha)+gamma_in(i_gamma,i_alpha);
      % Computation of the group propagation angles
      beta_s_group=phase_group_ang(s_func,s_der_func,s_par,1,'s',beta_s_phase);
      beta_r_group=phase_group_ang(s_func,s_der_func,s_par,1,'r',beta_r_phase);
      % Computation of the group reflection and aperture angles
      alpha_out(i_gamma,i_alpha)=.5*(beta_r_group + beta_s_group);
      gamma_out(i_gamma,i_alpha)=.5*(beta_r_group - beta_s_group);
    end
  end
end
