function [z_mov,mx_mov,gamma_pert,alpha_pert]=analy_rmo_aniso_bend(s_func,ds_drho_func,phase_match_der_func,s_par_inp,rho_inp,rho,z_norm,mx_norm,dz_dhx,dz_dmx,gamma,alpha,approx,flag)

% The input angles (gamma and alpha) are GROUP angles
[n_gamma,n_alpha]=size(gamma);

%n_rmo=z_norm*((rho(1)-rho_inp(1))/rho_inp(1))
for i_alpha=1:n_alpha
  for i_gamma=1:n_gamma
    alp_phase=alpha(i_gamma,i_alpha); % right only for flat events
    gam_phase=atand(dz_dhx(i_gamma,i_alpha)); % right only for flat events
    
    if(approx ==1)
      gam_group=gam_phase; % We approximate the group angles with the
                          % phase angles
    else
      gam_group=gamma(i_gamma,i_alpha); % We use the actual group angles 
    end
    
    % Evaluate quantities at linearization point
    Srho_inp=s_func(s_par_inp,gam_group,'group','s'); % Group slowness -
                                                      % Inputs are the
                                                      % group angles
    ds_drho=ds_drho_func(s_func,s_par_inp,gam_group,rho_inp,'group','s');
    dL_ds=-z_norm/(cosd(gam_group)*Srho_inp);
    
    % Set stationary ray paths
    gamma_pert(i_gamma,i_alpha)=gam_phase; % The output angle is the PHASE angle 
    alpha_pert(i_gamma,i_alpha)=alp_phase; % The output dip is the PHASE dip

    dz_dL=cosd(gam_group) + sind(gam_group)*tand(gam_phase);
    
    if((rho(1) == rho(2)) & (rho(1) == rho(3)))
      % If ``isotropic'' perturbation
      gam_phase_rho=gam_phase;
      gam_group_rho=gam_group;
      dz_drho(1)=(z_norm)*(1+tand(gam_phase_rho)*tand(gam_group_rho));
      dz_drho(2)=0.;
      dz_drho(3)=0.;
    else
      dz_drho(1)=ds_drho(1)*dL_ds*dz_dL;
      dz_drho(2)=ds_drho(2)*dL_ds*dz_dL;
      dz_drho(3)=ds_drho(3)*dL_ds*dz_dL;
    end
   
    n_rmo=dz_drho(1)*(rho(1)-rho_inp(1)) + ...
          dz_drho(2)*(rho(2)-rho_inp(2)) + ...
          dz_drho(3)*(rho(3)-rho_inp(3));
    
    z_mov(i_gamma,i_alpha)=z_norm+cosd(alp_phase)*n_rmo;
    mx_mov(i_gamma,i_alpha)=mx_norm+sind(alp_phase)*n_rmo;
    
  end
end

