function [t,mx,hx]=gen_model_ang(s_func,s_par,z_ref,mx_ref,gamma,alpha,flag)

[n_gamma,n_alpha]=size(gamma);

for i_alpha=1:n_alpha
  for i_gamma=1:n_gamma
    gam=gamma(i_gamma,i_alpha);
    alp=alpha(i_gamma,i_alpha);
    if(abs(cosd(alp)) > abs(sind(gam)))
     
      % All the following relationships can be found from the ray geometry
      inv_den=1./(cosd(alp)^2-sind(gam)^2);
      hx(i_gamma,i_alpha)=z_ref*sind(gam)*cosd(gam)*inv_den;
      mx(i_gamma,i_alpha)=mx_ref + z_ref*sind(alp)*cosd(alp)*inv_den;
      beta_s=alp-gam;
      beta_r=alp+gam;
      t(i_gamma,i_alpha)=z_ref* ...
          (s_func(s_par,beta_s,'group','s')/cosd(beta_s) + ...
           s_func(s_par,beta_r,'group','r')/cosd(beta_r));
    else
      t(i_gamma,i_alpha)=flag;
      hx(i_gamma,i_alpha)=NaN;
      mx(i_gamma,i_alpha)=NaN;
    end
  end
end

