function [z,mx,hx]=gen_surf_ang(s_func,s_par,t_data_inp,mx_data_inp,hx_data_inp,gamma,alpha,flag)

[n_gamma,n_alpha]=size(gamma);

ts=size(t_data_inp);
if((ts(1) == 1) & (ts(2) == 1))
  for i_alpha=1:n_alpha
    for i_gamma=1:n_gamma
      t_data(i_gamma,i_alpha)=t_data_inp;
      mx_data(i_gamma,i_alpha)=mx_data_inp;
      hx_data(i_gamma,i_alpha)=hx_data_inp;
    end
  end
else
  if((ts(1) ~= n_gamma) & (ts(2) ~= n_alpha))
    disp('gen_surf_ang: error with mismatching sizes')
    dbquit
  end
  % Copy of the input data
  t_data=t_data_inp;
  mx_data=mx_data_inp;
  hx_data=hx_data_inp;
end

for i_alpha=1:n_alpha
  for i_gamma=1:n_gamma
    % Gamma and Alpha are the group angles
    gam=gamma(i_gamma,i_alpha);
    alp=alpha(i_gamma,i_alpha);
    if(abs(cosd(alp)) > abs(sind(gam)))
      S_s=s_func(s_par,alp-gam,'group','s');
      S_r=s_func(s_par,alp+gam,'group','r');
      cos_s=cosd(alp-gam);
      cos_r=cosd(alp+gam);
      % Computation of the migration response (function of z, m and h -
      % subsirface offset)
      L=t_data(i_gamma,i_alpha)/((S_s+S_r) + (S_r-S_s)*tand(alp)*tand(gam));
      z(i_gamma,i_alpha)=L*(cosd(alp)^2-sind(gam)^2)/(cosd(alp)*cosd(gam));
      mx(i_gamma,i_alpha)=mx_data(i_gamma,i_alpha)-L*sind(alp)/cosd(gam);
      hx(i_gamma,i_alpha)=hx_data(i_gamma,i_alpha)-L*sind(gam)/cosd(alp);
    else
      z(i_gamma,i_alpha)=flag;
      mx(i_gamma,i_alpha)=NaN;
      hx(i_gamma,i_alpha)=NaN;
    end
  end
end

