#!/usr/bin/env python
import sys,types,string,commands
import SEP.args      #renamed from par
import SEP.pj_base   #rename from par_job
import SEP.pf_split  #parfile split to pf_split and pf_copy
import SEP.pf_copy   

SEP.spawn.print_all=1  #Print every command
SEP.util.debug=1   #Tell me where I have an error


pars=SEP.args.sep_args()                #get the command line arguments
command   = pars.par("command",error=1)[0]  #get the command to run
SEP.util.msg("command=%s"%command)
pars.del_par("command")   #delete the command from the parameter list

#global_bin   = pars.par("global_bin",error=1)[0]  
#SEP.util.msg("global_bin=%s"%global_bin)
#pars.del_par("global_bin")  

local_bin   = pars.par("local_bin",error=1)[0]  
SEP.util.msg("local_bin=%s"%local_bin)
pars.del_par("local_bin")  

#SEP.util.msg("copy executable %s%s in %s%s "%(global_bin,command,local_bin,command))
#stat,out=commands.getstatusoutput("cp -f %s%s %s%s"%(global_bin,command,local_bin,command))

#local_command = local_bin+command
#SEP.util.msg("local_command=%s"%local_command)

nblock = pars.par("nblock",  error=1)[0]  #the number of pieces to break data in
SEP.util.msg("nblock=%s"%nblock)
#msg="nblock=%s"%nblock
#SEP.util.msg(msg)

pars.del_par("nblock")

#Create sections
isect_dict= SEP.pj_func.simple_section_list(int(nblock))
sect_pars = SEP.pj_func.simple_parameter_list(int(nblock))



restart=pars.logic("restart")
SEP.util.msg("restart=%s"%restart)
SEP.util.msg("restart (after checking)=%s"%restart)

files_dict={}  # make a dictionary of the files we want to distribute

#FREQUENCY DESCRITION
data    = pars.par("data",   error=1)[0]  #get the input data

SEP.util.msg("data=%s"%data)

pars.del_par("data")
files_dict["data"]=SEP.pf_split.parfile( #we distribute the frequency file
  name=data,             #SEPlib file 
  dff_axis=4,            #axis we are distributing along
  usage="OUTPUT",         #input dataset
  tag="Data=",              #how the program references the file
  restart=restart,       #whether or not restart
  njobs=nblock,          #number of jobs (because nblock can n-d)
  nblock=nblock)         #the number of blocks the data is broken into


#SLOWNESS DESCRIPTION
slow   = pars.par("slow",   error=1)[0]  #get the velocity model

SEP.util.msg("slow=%s"%slow)

pars.del_par("slow")
files_dict["slow"]=SEP.pf_copy.parfile( #we share the slowness file
  name=slow,             #SEPlib file 
  usage="INPUT",         #input dataset
  tag="Slow=",              #how the program references the file
  njobs=nblock,          #number of jobs (because nblock can n-d)
  restart=restart)       #whether or not restart



#IMAGE DESCRIPTION
image   = pars.par("image",   error=1)[0]  #get the image
SEP.util.msg("image=%s"%image)
pars.del_par("image")
files_dict["image"]=SEP.pf_copy.parfile( #we share the image file
  name=image,            #SEPlib file 
  usage="INPUT",        #output dataset
  tag="Image=",              #how the program references the file
  reuse_par="add=y",	# to add to the image
  njobs=nblock,          #number of jobs (because nblock can n-d)
  restart=restart)       #whether or not restart


#create the parallel job
#machine file 
mfile,err   = pars.par("mfile","mfile") #the machine file
SEP.util.msg("mfile=%s"%mfile)
if err==1: pars.del_par("mfile")

logdir,err   = pars.par("logdir","stat") #the log directory
SEP.util.msg("logdir=%s"%logdir)
if err==1: pars.del_par("logdir")

device,err   = pars.par("device","eth1") #the log directory
SEP.util.msg("device=%s"%device)
if err==1: pars.del_par("device")

verb,err   = pars.par("par_verb",3) #the verbosity level
if err==1: pars.del_par("par_verb")


#dsep=SEP.sepfile.sep_file(file=data)
#nfreq=dsep.axis(4)[0]
#SEP.util.msg("nfreq=%s"%nfreq)

#z_data_0,err=dsep.history.par("z_data_0")
#SEP.util.msg("z_data_0=%s"%z_data_0)
#

pars.add_param("<","/dev/null")
#pars.add_param("z_data_0",z_data_0)
#z_image_0=0
#n_z_image=210
#d_z_image=.002


print "ABBB",pars.param("nblock"),pars.param("first_adj")

test1=SEP.pj_base.parjob(
   files=files_dict,        #the list of parallel files
   sect_pars=sect_pars,    #the parameters for the individual jobs
   program=command,           #the program we are running
   mach_mfile=mfile,            #the machine file #renamed
   verb=verb,              #how verbose
   global_pars=pars,       #params for all jobs
   restart_com="restart=y",
   attempts=5,  # how many time retrying on a sub task
   device=device,
   logdir=logdir)          #logging directory

test1.run_job(restart)     #run the parallel job

#test1.clean_files(0)
#test1.clean()
