!------------------------------------
program test3


use sep
implicit none
!-------------------------------------
integer					:: n1, ng, n3, n4, n5, i, i1, ig, i3, i4, i5, j
real 					:: delta, epsilon, V0, t0, rhovv, rhovh, rhovn, z0m
real                                    :: o1, og, o3, o4, o5, d1, dg, d3, d4, d5
real                                    :: vvt, vht, vnt, vvm, vhm, vnm
real, dimension(:,:,:,:,:), allocatable       :: adcig
real, dimension(:),allocatable          :: gamma, Sell, Svti, DE1, DE2, DS1, DS2, DS3, DZ1, DZ2, DZ3, rmo, zm
 
!--------------------------------

call sep_init()

call from_param( "n1", n1) ! Depth axis
call from_param( "o1", o1) 
call from_param( "d1", d1) 
call from_param( "ng", ng) ! Reflection Angle axis
call from_param( "og", og)
call from_param( "dg", dg)
call from_param( "n3", n3) ! Rhovv axis
call from_param( "o3", o3)
call from_param( "d3", d3)
call from_param( "n4", n4) ! Rhovh parameter
call from_param( "o4", o4)
call from_param( "d4", d4)
call from_param( "n5", n5) ! Rhovn parameter
call from_param( "o5", o5)
call from_param( "d5", d5)
call from_param( "V0", V0) 
call from_param( "delta", delta)
call from_param( "epsilon", epsilon)
call from_param( "t0", t0)
call from_param( "rhovv", rhovv)
call from_param( "rhovh", rhovh)
call from_param( "rhovn", rhovn)

call sep_close()

allocate(adcig(n1,ng,1,1,1))
adcig=0

vvt=V0;
vht=V0*sqrt(1+2*epsilon);
vnt=V0*sqrt(1+2*delta);
vvm=vvt*rhovv;
vhm=vht*rhovh;
vnm=vnt*rhovn;

allocate(gamma(ng))
do ig=1,ng
   gamma(ig)=og+(ig-1)
end do

! We compute the different derivatives with respect to the different parameters

allocate(Sell(ng),Svti(ng),DE1(ng),DE2(ng),DS1(ng),DS2(ng),DS3(ng),DZ1(ng),DZ2(ng),DZ3(ng))
Sell=sqrt(vvm**2*cosd(gamma)**2+vhm**2*sind(gamma)**2)
Svti=sqrt((Sell**2+sqrt(Sell**4+vvm**2*(vnm**2-vhm**2)*sind(2*gamma)**2))/2)
DE1=-vvm**2*cosd(gamma)**2/Sell
DE2=-vhm**2*sind(gamma)**2/Sell
DS1=Sell/(2*Svti)*DE1+(2*DE1*Sell**3-vvm**2*(vnm**2-vhm**2)*sind(2*gamma)**2)/(4*Svti*sqrt(Sell**4+vvm**2*(vnm**2-vhm**2)*sind(2*gamma)**2))
DS2=Sell/(2*Svti)*DE2+(2*DE2*Sell**3+vvm**2*vhm**2*sind(2*gamma)**2)/(4*Svti*sqrt(Sell**4+vvm**2*(vnm**2-vhm**2)*sind(2*gamma)**2))
DS3=-(vvm**2*vhm**2*sind(2*gamma)**2)/(4*Svti*sqrt(Sell**4+vvm**2*(vnm**2-vhm**2)*sind(2*gamma)**2))
DZ1=-1/Svti*DS1*(1+tand(gamma)**2)-1
DZ2=-1/Svti*DS2*(1+tand(gamma)**2)
DZ3=-1/Svti*DS3*(1+tand(gamma)**2)

deallocate(Sell,Svti,DE1,DE2,DS1,DS2,DS3)

! do i=1,n2
!   write(0,*) gamma(i)
!end do
! We compute the theoretical ADCIG

adcig=0;
z0m=t0*vvm;
allocate(rmo(ng),zm(ng))
rmo=z0m*(DZ1*(rhovv-1)+DZ2*(rhovh-1)+DZ3*(rhovn-1)) ! Computation of the theoretical RMO
zm=z0m+rmo

!do i=1,n2
!   write(0,*) zm(i)
!end do


do ig=1,ng
   j=(zm(ig)-o1)/d1+1.5
   adcig(j,ig,1,1,1)=1
end do

call sep_write(adcig)

end program test3
