# 1 "<stdin>"
# 1 "<built-in>"
# 1 "<command line>"
# 1 "<stdin>"
module gendown3d_types

  integer, parameter :: status_init=0
  integer, parameter :: mem_fixed_init=0
  integer, parameter :: mem_n_w_inp_init=0
  integer, parameter :: mem_n_mx_inp_init=0
  integer, parameter :: mem_n_my_inp_init=0
  integer, parameter :: mem_n_hx_inp_init=0
  integer, parameter :: mem_n_hy_inp_init=0

  type gendown3d_info_type
     integer :: status = status_init
     integer :: mem_fixed = mem_fixed_init
     integer :: mem_n_w_inp = mem_n_w_inp_init
     integer :: mem_n_mx_inp = mem_n_mx_inp_init
     integer :: mem_n_my_inp = mem_n_my_inp_init
     integer :: mem_n_hx_inp = mem_n_hx_inp_init
     integer :: mem_n_hy_inp = mem_n_hy_inp_init
  end type gendown3d_info_type

! type(gendown3d_info_type), parameter :: info_default = gendown3d_info_type &
! (status_init, &
! mem_fixed_init, &
! mem_n_w_inp_init, &
! mem_n_mx_inp_init, &
! mem_n_my_inp_init, &
! mem_n_hx_inp_init, &
! mem_n_hy_inp_init )

  logical, parameter :: verb_init=.true.
  logical, parameter :: debug1_init=.false.
  logical, parameter :: debug2_init=.false.
  logical, parameter :: save_memory_init=.false.
  logical, parameter :: timers_on_init=.false.
  logical, parameter :: rho_filt_init=.false.
  logical, parameter :: image_zero_offset_init=.true.
  logical, parameter :: image_cig_init=.false.
  logical, parameter :: k_domain_init=.true.
  logical, parameter :: first_adj_init=.false.
  logical, parameter :: first_add_init=.false.
  logical, parameter :: check_stability_init=.false.
  logical, parameter :: complex_image_init=.false.
  logical, parameter :: synth_data_init=.false.
  logical, parameter :: no_data_init=.false.
  logical, parameter :: single_hx_dip_init=.false.
  logical, parameter :: time_mig_init=.false.
  logical, parameter :: write_down_data_pad_init=.false.
  logical, parameter :: apply_bound_init=.false.
  logical, parameter :: transf_wei_init=.false.

  ! choices 'cons-slow' 'back_slow' 'full_slow' 'pert_slow'
  character(len=128), parameter :: oper_type_init='full_slow'
  character(len=128), parameter :: domain_range_init='slow_ima'
  character(len=128), parameter :: cig_forw_transf_init='pull'
  character(len=128), parameter :: amp_weights_init='none'

  integer, parameter :: n_threads_init=-1
  integer, parameter :: max_memory_init=134217728
  integer, parameter :: non_data_memory_init=0

  integer, parameter :: n_data_dim_init=4
  integer, parameter :: n_mx_pad_init=-huge(1)/10.
  integer, parameter :: n_my_pad_init=-huge(1)/10.
  integer, parameter :: n_hx_pad_init=-huge(1)/10.
  integer, parameter :: n_hy_pad_init=-huge(1)/10.
  integer, parameter :: n_z_image_init=-1

  integer, parameter :: n_w_block_init=-1
  integer, parameter :: n_z_block_init=-1
  integer, parameter :: i_block_z_restart_init=-1

  integer, parameter :: i_hx_0_shift_start_init=1
  integer, parameter :: n_hx_0_shift_period_init=1

  real, parameter :: slow_const_init=-1.
  real, parameter :: slow_const_image_init=-1.
  real, parameter :: slow_const_image_z0_init=-1.
  real, parameter :: slow_scale_init=1.
  real, parameter :: stat_shift_init=0.
  real, parameter :: max_propag_angle_init=89.
  real, parameter :: z_image_0_init=-1.
  real, parameter :: d_z_image_init=-1.
  real, parameter :: t_spike_0_init=-1.
  real, parameter :: mx_spike_0_init=huge(1.)/10.
  real, parameter :: my_spike_0_init=huge(1.)/10.
  real, parameter :: hx_spike_0_init=huge(1.)/10.
  real, parameter :: hy_spike_0_init=huge(1.)/10.
  real, parameter :: t_spike_1_init=-1.
  real, parameter :: mx_spike_1_init=huge(1.)/10.
  real, parameter :: my_spike_1_init=huge(1.)/10.
  real, parameter :: hx_spike_1_init=huge(1.)/10.
  real, parameter :: hy_spike_1_init=huge(1.)/10.
  real, parameter :: px_plane_0_init=0.
  real, parameter :: py_plane_0_init=0.
  real, parameter :: px_plane_1_init=0.
  real, parameter :: py_plane_1_init=0.

  real, parameter :: freq_min_0_init=-1.
  real, parameter :: freq_min_1_init=-1.
  real, parameter :: freq_max_0_init=-1.
  real, parameter :: freq_max_1_init=-1.

  real, parameter :: freq_min_amp_init=-1.
  real, parameter :: freq_max_amp_init=-1.
  real, parameter :: freq_pow_scale_init=0.

  real, parameter :: hx_0_shift_init=0

  type gendown3d_param_type
     logical :: verb=verb_init
     logical :: debug1=debug1_init
     logical :: debug2=debug2_init
     logical :: save_memory=save_memory_init
     logical :: timers_on=timers_on_init
     logical :: rho_filt=rho_filt_init
     logical :: image_zero_offset=image_zero_offset_init
     logical :: image_cig=image_cig_init
     logical :: k_domain=k_domain_init
     logical :: first_adj=first_adj_init
     logical :: first_add=first_add_init
     logical :: check_stability=check_stability_init
     logical :: complex_image=complex_image_init
     logical :: synth_data=synth_data_init
     logical :: no_data=no_data_init
     logical :: single_hx_dip=single_hx_dip_init
     logical :: time_mig=time_mig_init
     logical :: write_down_data_pad=write_down_data_pad_init
     logical :: apply_bound=apply_bound_init
     logical :: transf_wei=transf_wei_init

     character(len=128) :: oper_type=oper_type_init
     character(len=128) :: domain_range=domain_range_init
     character(len=128) :: cig_forw_transf=cig_forw_transf_init
     character(len=128) :: amp_weights=amp_weights_init

     integer :: n_threads=n_threads_init
     integer :: max_memory=max_memory_init
     integer :: non_data_memory=non_data_memory_init

     integer :: n_data_dim=n_data_dim_init
     integer :: n_mx_pad=n_mx_pad_init
     integer :: n_my_pad=n_my_pad_init
     integer :: n_hx_pad=n_hx_pad_init
     integer :: n_hy_pad=n_hy_pad_init
     integer :: n_z_image=n_z_image_init

     integer :: n_w_block=n_w_block_init
     integer :: n_z_block=n_z_block_init

     integer :: i_block_z_restart=i_block_z_restart_init
     integer :: i_hx_0_shift_start=i_hx_0_shift_start_init
     integer :: n_hx_0_shift_period=n_hx_0_shift_period_init

     real :: slow_const=slow_const_init
     real :: slow_const_image=slow_const_image_init
     real :: slow_const_image_z0=slow_const_image_z0_init
     real :: slow_scale=slow_scale_init
     real :: stat_shift=stat_shift_init
     real :: max_propag_angle=max_propag_angle_init
     real :: z_image_0=z_image_0_init
     real :: d_z_image=d_z_image_init
     real :: t_spike_0=t_spike_0_init
     real :: mx_spike_0=mx_spike_0_init
     real :: my_spike_0=my_spike_0_init
     real :: hx_spike_0=hx_spike_0_init
     real :: hy_spike_0=hy_spike_0_init
     real :: t_spike_1=t_spike_1_init
     real :: mx_spike_1=mx_spike_1_init
     real :: my_spike_1=my_spike_1_init
     real :: hx_spike_1=hx_spike_1_init
     real :: hy_spike_1=hy_spike_1_init
     real :: px_plane_0=px_plane_0_init
     real :: py_plane_0=py_plane_0_init
     real :: px_plane_1=px_plane_1_init
     real :: py_plane_1=py_plane_1_init

     real :: freq_min_0=freq_min_0_init
     real :: freq_min_1=freq_min_1_init
     real :: freq_max_0=freq_max_0_init
     real :: freq_max_1=freq_max_1_init
     real :: freq_min_amp=freq_min_amp_init
     real :: freq_max_amp=freq_max_amp_init
     real :: freq_pow_scale=freq_pow_scale_init
     real :: hx_0_shift=hx_0_shift_init

  end type gendown3d_param_type
end module gendown3d_types
