subroutine param_gen(gen_par)
  use gendown3d_types
  use sep

  implicit none
  type (gendown3d_param_type) gen_par

  logical image_cra
  !integer, intrinsic ::  mp_numthreads
!  integer ::  mp_numthreads
  integer, external :: omp_get_num_threads
  integer, external :: auxpar,getch,fetch,auxin,sreed,sseek,auxout

  integer n_threads_env
  real :: freq_min_0,freq_min_1,freq_max_0,freq_max_1
!  real :: freq_min_amp,freq_max_amp

  call from_param('oper_type',gen_par%oper_type,trim(gen_par%oper_type))
!  call to_history('oper_type',gen_par%oper_type)

  call from_param('domain_range',gen_par%domain_range,trim(gen_par%domain_range))
!  call to_history('domain_range',gen_par%domain_range)
  call from_param('verb',gen_par%verb,gen_par%verb)
!  call to_history('verb',gen_par%verb)
  call from_param('debug1',gen_par%debug1,gen_par%debug1)
!  call to_history('debug1',gen_par%debug1)
  call from_param('debug2',gen_par%debug2,gen_par%debug2)
!  call to_history('debug2',gen_par%debug2)

  call from_param('save_memory',gen_par%save_memory,gen_par%save_memory)

  call from_param('timers_on',gen_par%timers_on,gen_par%timers_on)
!  call to_history('timers_on',gen_par%timers_on)
  call from_param('rho_filt',gen_par%rho_filt,gen_par%rho_filt)
!  call to_history('rho_filt',gen_par%rho_filt)
  call from_param('image_zero_offset',gen_par%image_zero_offset,gen_par%image_zero_offset)
!  call to_history('image_zero_offset',gen_par%image_zero_offset)

  call from_param('image_cra',image_cra,.false.)
!  call to_history('image_cra',image_cra)
  call from_param('image_cig',gen_par%image_cig,gen_par%image_cig)
!  call to_history('image_cig',gen_par%image_cig)
  if(image_cra .and. (gen_par%image_cig .neqv. image_cra)) then
    write(0,*)'image_cig and image_cra are different'
    write(0,*)'The use of image_cra is deprecated'
    call seperr('Please change image_cra into image_cig in your parameters')
  end if
  call from_param('cig_forw_transf',gen_par%cig_forw_transf,gen_par%cig_forw_transf)
!  call to_history('cig_forw_transf',gen_par%cig_forw_transf)

  call from_param('amp_weights',gen_par%amp_weights,gen_par%amp_weights)
!  call to_history('amp_weights',gen_par%amp_weights)

  call from_param('k_domain',gen_par%k_domain,gen_par%k_domain)
!  call to_history('k_domain',gen_par%k_domain)

  call from_param('first_adj',gen_par%first_adj,gen_par%first_adj)
!  call to_history('first_adj',gen_par%first_adj)
  call from_param('first_add',gen_par%first_add,gen_par%first_add)
!  call to_history('first_add',gen_par%first_add)
  call from_param('check_stability',gen_par%check_stability,gen_par%check_stability)
!  call to_history('check_stability',gen_par%check_stability)
  call from_param('complex_image',gen_par%complex_image,gen_par%complex_image)
!  call to_history('complex_image',gen_par%complex_image)
  call from_param('synth_data',gen_par%synth_data,gen_par%synth_data)
!  call to_history('synth_data',gen_par%synth_data)
  call from_param('no_data',gen_par%no_data,gen_par%no_data)
!  call to_history('no_data',gen_par%no_data)
  call from_param('single_hx_dip',gen_par%single_hx_dip,gen_par%single_hx_dip)
!  call to_history('single_hx_dip',gen_par%single_hx_dip)
  call from_param('time_mig',gen_par%time_mig,gen_par%time_mig)
!  call to_history('time_mig',gen_par%time_mig)

  call from_param('transf_wei',gen_par%transf_wei,gen_par%transf_wei)

  call from_param('n_threads',gen_par%n_threads,gen_par%n_threads)
!  call to_history('n_threads',gen_par%n_threads)
  call from_param('max_memory',gen_par%max_memory,gen_par%max_memory)
!  call to_history('max_memory',gen_par%max_memory)

  call from_param('n_data_dim',gen_par%n_data_dim,gen_par%n_data_dim)
!  call to_history('n_data_dim',gen_par%n_data_dim)
  call from_param('n_mx_pad',gen_par%n_mx_pad,gen_par%n_mx_pad)
!  call to_history('n_mx_pad',gen_par%n_mx_pad)
  call from_param('n_my_pad',gen_par%n_my_pad,gen_par%n_my_pad)
!  call to_history('n_my_pad',gen_par%n_my_pad)
  call from_param('n_hx_pad',gen_par%n_hx_pad,gen_par%n_hx_pad)
!  call to_history('n_hx_pad',gen_par%n_hx_pad)
  call from_param('n_hy_pad',gen_par%n_hy_pad,gen_par%n_hy_pad)
!  call to_history('n_hy_pad',gen_par%n_hy_pad)

  call from_param('n_w_block',gen_par%n_w_block,gen_par%n_w_block)
!  call to_history('n_w_block',gen_par%n_w_block)
  call from_param('n_z_block',gen_par%n_z_block,gen_par%n_z_block)
!  call to_history('n_z_block',gen_par%n_z_block)
  call from_param('i_block_z_restart',gen_par%i_block_z_restart,gen_par%i_block_z_restart)
!  call to_history('i_block_z_restart',gen_par%i_block_z_restart)

  call from_param('i_hx_0_shift_start',gen_par%i_hx_0_shift_start,gen_par%i_hx_0_shift_start)
  call from_param('n_hx_0_shift_period',gen_par%n_hx_0_shift_period,gen_par%n_hx_0_shift_period)

  call from_param('slow_const',gen_par%slow_const,gen_par%slow_const)
!  call to_history('slow_const',gen_par%slow_const)
  call from_param('slow_const_image',gen_par%slow_const_image, &
                   gen_par%slow_const_image)
  call from_param('slow_const_image_z0',gen_par%slow_const_image_z0, &
                   gen_par%slow_const_image_z0)
!  call to_history('slow_const_image',gen_par%slow_const_image)
  call from_param('slow_scale',gen_par%slow_scale,gen_par%slow_scale)
  call from_param('stat_shift',gen_par%stat_shift,gen_par%stat_shift)
!  call to_history('slow_scale',gen_par%slow_scale)
  call from_param('max_propag_angle',gen_par%max_propag_angle,gen_par%max_propag_angle)
!  call to_history('max_propag_angle',gen_par%max_propag_angle)
  call from_param('t_spike_0',gen_par%t_spike_0,gen_par%t_spike_0)
!  call to_history('t_spike_0',gen_par%t_spike_0)
  call from_param('mx_spike_0',gen_par%mx_spike_0,gen_par%mx_spike_0)
!  call to_history('mx_spike_0',gen_par%mx_spike_0)
  call from_param('my_spike_0',gen_par%my_spike_0,gen_par%my_spike_0)
!  call to_history('my_spike_0',gen_par%my_spike_0)
  call from_param('hx_spike_0',gen_par%hx_spike_0,gen_par%hx_spike_0)
!  call to_history('hx_spike_0',gen_par%hx_spike_0)
  call from_param('hy_spike_0',gen_par%hy_spike_0,gen_par%hy_spike_0)
!  call to_history('hy_spike_0',gen_par%hy_spike_0)
  call from_param('t_spike_1',gen_par%t_spike_1,gen_par%t_spike_1)
!  call to_history('t_spike_1',gen_par%t_spike_1)
  call from_param('mx_spike_1',gen_par%mx_spike_1,gen_par%mx_spike_1)
!  call to_history('mx_spike_1',gen_par%mx_spike_1)
  call from_param('my_spike_1',gen_par%my_spike_1,gen_par%my_spike_1)
!  call to_history('my_spike_1',gen_par%my_spike_1)
  call from_param('hx_spike_1',gen_par%hx_spike_1,gen_par%hx_spike_1)
!  call to_history('hx_spike_1',gen_par%hx_spike_1)
  call from_param('hy_spike_1',gen_par%hy_spike_1,gen_par%hy_spike_1)
!  call to_history('hy_spike_1',gen_par%hy_spike_1)

  call from_param('px_plane_0',gen_par%px_plane_0,gen_par%px_plane_0)
!  call to_history('px_plane_0',gen_par%px_plane_0)
  call from_param('py_plane_0',gen_par%py_plane_0,gen_par%py_plane_0)
!  call to_history('py_plane_0',gen_par%py_plane_0)
  call from_param('px_plane_1',gen_par%px_plane_1,gen_par%px_plane_1)
!  call to_history('px_plane_1',gen_par%px_plane_1)
  call from_param('py_plane_1',gen_par%py_plane_1,gen_par%py_plane_1)
!  call to_history('py_plane_1',gen_par%py_plane_1)

  call from_param('freq_min_0',gen_par%freq_min_0,gen_par%freq_min_0)
!  call to_history('freq_min_0',gen_par%freq_min_0)
  call from_param('freq_min_1',gen_par%freq_min_1,gen_par%freq_min_1)
!  call to_history('freq_min_1',gen_par%freq_min_1)
  call from_param('freq_max_0',gen_par%freq_max_0,gen_par%freq_max_0)
!  call to_history('freq_max_0',gen_par%freq_max_0)
  call from_param('freq_max_1',gen_par%freq_max_1,gen_par%freq_max_1)
!  call to_history('freq_max_1',gen_par%freq_max_1)

  call from_param('freq_min_amp',gen_par%freq_min_amp,gen_par%freq_min_amp)
  call from_param('freq_max_amp',gen_par%freq_max_amp,gen_par%freq_max_amp)

  call from_param('freq_pow_scale',gen_par%freq_pow_scale,gen_par%freq_pow_scale)

  call from_param('hx_0_shift',gen_par%hx_0_shift,gen_par%hx_0_shift)

  ! output parameters
  call from_param('n_z_image',gen_par%n_z_image)
!  call to_history('n_z_image',gen_par%n_z_image)
  call from_param('z_image_0',gen_par%z_image_0,0.)
!  call to_history('z_image_0',gen_par%z_image_0)
  call from_param('d_z_image',gen_par%d_z_image)
!  call to_history('d_z_image',gen_par%d_z_image)


! checking parameters
!n_threads_env=mp_numthreads()
!!call omp_set_num_threads(2)

!$omp parallel
  n_threads_env=omp_get_num_threads()
!$omp end parallel
  !n_threads_env=1 ! BUG to be changed when we have Power Fortran
  if(gen_par%n_threads == n_threads_init) then
     gen_par%n_threads=n_threads_env
  else
     if(n_threads_env > gen_par%n_threads) then
        call omp_set_num_threads(gen_par%n_threads)
        write(0,*)'WARNING: overwriting environment variable'
        write(0,*)'gen_par-n_threads=',gen_par%n_threads
     end if
     if(n_threads_env < gen_par%n_threads) then
        write(0,*)'gen_par-n_threads=',gen_par%n_threads
        write(0,*)'OMP_NUM_THREADS=',n_threads_env
        call seperr('ERROR: Asked for more threads than the environment variable allows')
     end if
  end if
  if(gen_par%debug1)write(0,*)'gen_par-n_threads=',gen_par%n_threads
  call to_history('n_threads',gen_par%n_threads)

  !coverting domain_range to standard strings
  select case (gen_par%domain_range(1:9))
  case ('data_imag')
     gen_par%domain_range(1:9)='data_imag'
  case ('data_wave')
     gen_par%domain_range(1:9)='data_wave'
  case ('slow_imag')
  case ('dslow_dim')
     gen_par%domain_range(1:9)='dslow_dim'
  case default
     write(0,*)'gen_par-domain_range=',trim(gen_par%domain_range)
     call seperr('Not supported domain_range')
  end select


  return
end subroutine param_gen


subroutine param_data(gen_par,data_par)
  use gendown3d_types
  use data_types
  use sep

  implicit none

  type (gendown3d_param_type) gen_par
  type (data_param_type) data_par

  logical write_down_data,write_down_ddata
  character(len=128) :: tag_name
  integer, external :: auxpar,getch,fetch,auxin,sreed,sseek,auxout,auxinout
  integer i_one,n_freq,ierr
  integer n1,n2,n3,n4,n5,esize
  real d1,d2,d3,d4,d5,o1,o2,o3,o4,o5,z0,t0
  real pi,freq_0,d_freq,new_z_data_0

  i_one=1
  data_par%esize_data=8
  data_par%esize_ddata=8
  data_par%esize_wavefield=8

  call from_param('tag_data',data_par%tag_data,'Data')
!  call to_history('tag_data',data_par%tag_data)
  call from_param(trim(data_par%tag_data),tag_name,'Data not found')
!  call to_history('Data_history',tag_name)

  call from_param('tag_ddata',data_par%tag_ddata,'Ddata')
!  call to_history('tag_ddata',data_par%tag_ddata)
  call from_param(trim(data_par%tag_ddata),tag_name,'Ddata not found')
!  call to_history('Ddata_history',tag_name)

  call from_param('tag_down_data',data_par%tag_down_data,'Down_data')
!  call to_history('tag_down_data',data_par%tag_down_data)
  call from_param(trim(data_par%tag_down_data),tag_name,'Down_data not found')
!  call to_history('Down_data_history',tag_name)

  call from_param('tag_down_ddata',data_par%tag_down_ddata,'Down_ddata')
!  call to_history('tag_down_ddata',data_par%tag_down_ddata)
  call from_param(trim(data_par%tag_down_ddata),tag_name,'Down_ddata not found')
!  call to_history('Down_ddata_history',tag_name)

  call from_param('tag_wavefield',data_par%tag_wavefield,'Wavefield')
!  call to_history('tag_wavefield',data_par%tag_wavefield)
  call from_param(trim(data_par%tag_wavefield),tag_name,'Wavefield not found')
!  call to_history('Wavefield',tag_name)


  ! First deal with tag Data
  if(gen_par%domain_range(1:4) == 'data') then
     !{
     if (gen_par%first_adj) then
        !{
        ierr=auxinout('Data')
        data_par%data_file=DATA_OUTPUT
        call from_param('n1',data_par%n_mx)
!        call to_history('n1',data_par%n_mx)
        call from_param('n2',data_par%n_my)
!        call to_history('n2',data_par%n_my)
        call from_param('n3',data_par%n_hx)
!        call to_history('n3',data_par%n_hx)
        call from_param('d1',data_par%d_mx)
!        call to_history('d1',data_par%d_mx)
        call from_param('d2',data_par%d_my)
!        call to_history('d2',data_par%d_my)
        call from_param('d3',data_par%d_hx)
!        call to_history('d3',data_par%d_hx)
        call from_param('o1',data_par%mx_0,0.)
!        call to_history('o1',data_par%mx_0)
        call from_param('o2',data_par%my_0,0.)
!        call to_history('o2',data_par%my_0)
        call from_param('o3',data_par%hx_0,0.)
!        call to_history('o3',data_par%hx_0)

        if(gen_par%n_data_dim >4) then 
           call from_param('n4',data_par%n_hy)
!           call to_history('n4',data_par%n_hy)
           call from_param('n5',n_freq)
!           call to_history('n5',n_freq)
           call from_param('d4',data_par%d_hy)
!           call to_history('d4',data_par%d_hy)
           call from_param('d5',d_freq)
!           call to_history('d5',d_freq)
           call from_param('o4',data_par%hy_0,0.)
!           call to_history('o4',data_par%hy_0)
           call from_param('o5',freq_0,0.)
!           call to_history('o5',freq_0)
        else
           call from_param('n5',data_par%n_hy)
!           call to_history('n5',data_par%n_hy)
           call from_param('n4',n_freq)
!           call to_history('n4',n_freq)
           call from_param('d5',data_par%d_hy)
!           call to_history('d5',data_par%d_hy)
           call from_param('d4',d_freq)
!           call to_history('d4',d_freq)
           call from_param('o5',data_par%hy_0,0.)
!           call to_history('o5',data_par%hy_0)
           call from_param('o4',freq_0,0.)
!           call to_history('o4',freq_0)
        end if

        call to_history("esize",data_par%esize_data,'Data')
        call to_history("n1",data_par%n_mx,'Data')
        call to_history("n2",data_par%n_my,'Data')
        call to_history("n3",data_par%n_hx,'Data')
        call to_history("d1",data_par%d_mx,'Data')
        call to_history("d2",data_par%d_my,'Data')
        call to_history("d3",data_par%d_hx,'Data')
        call to_history("o1",data_par%mx_0,'Data')
        call to_history("o2",data_par%my_0,'Data')
        call to_history("o3",data_par%hx_0,'Data')
        if(gen_par%n_data_dim >4) then 
           call to_history("n4",data_par%n_hy,'Data')
           call to_history("n5",n_freq,'Data')
           call to_history("o4",data_par%hy_0,'Data')
           call to_history("o5",freq_0,'Data')
           call to_history("d4",data_par%d_hy,'Data')
           call to_history("d5",d_freq,'Data')
        else
           call to_history("n4",n_freq,'Data')
           call to_history("n5",data_par%n_hy,'Data')
           call to_history("o4",freq_0,'Data')
           call to_history("o5",data_par%hy_0,'Data')
           call to_history("d4",d_freq,'Data')
           call to_history("d5",data_par%d_hy,'Data')
        end if

        new_z_data_0=gen_par%z_image_0 
        call to_history("z_data_0",new_z_data_0,'Data')
        !}
     else
        !{
        if (gen_par%synth_data) then
           !{
           data_par%data_file=DATA_SYNTH
           call from_param('n1',data_par%n_mx)
!           call to_history('n1',data_par%n_mx)
           call from_param('n2',data_par%n_my)
!           call to_history('n2',data_par%n_my)
           call from_param('n3',data_par%n_hx)
!           call to_history('n3',data_par%n_hx)
           call from_param('d1',data_par%d_mx)
!           call to_history('d1',data_par%d_mx)
           call from_param('d2',data_par%d_my)
!           call to_history('d2',data_par%d_my)
           call from_param('d3',data_par%d_hx)
!           call to_history('d3',data_par%d_hx)
           call from_param('o1',data_par%mx_0,0.)
!           call to_history('o1',data_par%mx_0)
           call from_param('o2',data_par%my_0,0.)
!           call to_history('o2',data_par%my_0)
           call from_param('o3',data_par%hx_0,0.)
!           call to_history('o3',data_par%hx_0)
           call from_param('z_data_0',data_par%z_data_0)
!           call to_history('z_data_0',data_par%z_data_0)
           if(gen_par%n_data_dim >4) then 
              call from_param('n4',data_par%n_hy)
!              call to_history('n4',data_par%n_hy)
              call from_param('n5',n_freq)
!              call to_history('n5',n_freq)
              call from_param('d4',data_par%d_hy)
!              call to_history('d4',data_par%d_hy)
              call from_param('d5',d_freq)
!              call to_history('d5',d_freq)
              call from_param('o4',data_par%hy_0,0.)
!              call to_history('o4',data_par%hy_0)
              call from_param('o5',freq_0,0.)
!              call to_history('o5',freq_0)
           else
              call from_param('n5',data_par%n_hy)
!              call to_history('n5',data_par%n_hy)
              call from_param('n4',n_freq)
!              call to_history('n4',n_freq)
              call from_param('d5',data_par%d_hy)
!              call to_history('d5',data_par%d_hy)
              call from_param('d4',d_freq)
!              call to_history('d4',d_freq)
              call from_param('o5',data_par%hy_0,0.)
!              call to_history('o5',data_par%hy_0)
              call from_param('o4',freq_0,0.)
!              call to_history('o4',freq_0)
           end if
           if(gen_par%z_image_0 < data_par%z_data_0 ) then
              write(0,*)'gen_par%z_image_0=',gen_par%z_image_0
              write(0,*)'data_par%z_data_0=',data_par%z_data_0
              call seperr('z_image_0 < data_par-z_data_0')
           end if
           !}
        else
           !{
           ierr=auxinout('Data')
           data_par%data_file=DATA_INPUT

           call from_aux('Data',"esize",esize)

           call from_aux('Data',"n1",data_par%n_mx)
           call to_history("From Data: n1",data_par%n_mx)
           call from_aux('Data',"n2",data_par%n_my)
           call to_history("From Data: n2",data_par%n_my)
           call from_aux('Data',"n3",data_par%n_hx)
           call to_history("From Data: n3",data_par%n_hx)
           call from_aux('Data',"d1",data_par%d_mx)
           call to_history("From Data: d1",data_par%d_mx)
           call from_aux('Data',"d2",data_par%d_my)
           call to_history("From Data: d2",data_par%d_my)
           call from_aux('Data',"d3",data_par%d_hx)
           call to_history("From Data: d3",data_par%d_hx)
           call from_aux('Data',"o1",data_par%mx_0,0.)
           call to_history("From Data: o1",data_par%mx_0)
           call from_aux('Data',"o2",data_par%my_0,0.)
           call to_history("From Data: o2",data_par%my_0)
           call from_aux('Data',"o3",data_par%hx_0,0.)
           call to_history("From Data: o3",data_par%hx_0)
           if(gen_par%n_data_dim >4) then 
              call from_aux('Data',"n4",data_par%n_hy)
              call to_history("From Data: n4",data_par%n_hy)
              call from_aux('Data',"n5",n_freq)
              call to_history("From Data: n5",n_freq)
              call from_aux('Data',"d4",data_par%d_hy)
              call to_history("From Data: d4",data_par%d_hy)
              call from_aux('Data',"d5",d_freq)
              call to_history("From Data: d5",d_freq)
              call from_aux('Data',"o4",data_par%hy_0,0.)
              call to_history("From Data: o4",data_par%hy_0)
              call from_aux('Data',"o5",freq_0,0.)
              call to_history("From Data: o5",freq_0)
           else
              call from_aux('Data',"n4",n_freq)
              call to_history("From Data: n4",n_freq)
              call from_aux('Data',"n5",data_par%n_hy,1)
              call to_history("From Data: n5",data_par%n_hy)
              call from_aux('Data',"d4",d_freq)
              call to_history("From Data: d4",d_freq)
              call from_aux('Data',"d5",data_par%d_hy,1.)
              call to_history("From Data: d5",data_par%d_hy)
              call from_aux('Data',"o4",freq_0,0.)
              call to_history("From Data: o4",freq_0)
              call from_aux('Data',"o5",data_par%hy_0,0.)
              call to_history("From Data: o5",data_par%hy_0)
           end if
           if(gen_par%time_mig) then
             call from_aux('Data',"t_data_0",data_par%t_data_0)
             call to_history("From Data: t_data_0",data_par%t_data_0)
           else
!             call from_aux('Data',"z_data_0",data_par%z_data_0)
             call from_aux('Data',"z_data_0",data_par%z_data_0,0.)
             call to_history("From Data: z_data_0",data_par%z_data_0)
           end if
           if(esize /= data_par%esize_data) call seperr('Data must be complex')
           if(gen_par%z_image_0 < data_par%z_data_0 ) then
              write(0,*)'gen_par%z_image_0=',gen_par%z_image_0
              write(0,*)'data_par%z_data_0=',data_par%z_data_0
              call seperr('z_image_0 < data_par-z_data_0')
           end if
           !}
        end if
        if(gen_par%debug1) write(0,*)'data_file=',data_par%data_file
        !}
     end if
     !}
  else
     !{
     if (gen_par%synth_data) then
        !{
        data_par%data_file=DATA_SYNTH
        call from_param('n1',data_par%n_mx)
!        call to_history('n1',data_par%n_mx)
        call from_param('n2',data_par%n_my)
!        call to_history('n2',data_par%n_my)
        call from_param('n3',data_par%n_hx)
!        call to_history('n3',data_par%n_hx)
        call from_param('d1',data_par%d_mx)
!        call to_history('d1',data_par%d_mx)
        call from_param('d2',data_par%d_my)
!        call to_history('d2',data_par%d_my)
        call from_param('d3',data_par%d_hx)
!        call to_history('d3',data_par%d_hx)
        call from_param('o1',data_par%mx_0,0.)
!        call to_history('o1',data_par%mx_0)
        call from_param('o2',data_par%my_0,0.)
!        call to_history('o2',data_par%my_0)
        call from_param('o3',data_par%hx_0,0.)
!        call to_history('o3',data_par%hx_0)
        if(gen_par%n_data_dim >4) then 
           call from_param('n4',data_par%n_hy)
!           call to_history('n4',data_par%n_hy)
           call from_param('n5',n_freq)
!           call to_history('n5',n_freq)
           call from_param('d4',data_par%d_hy)
!           call to_history('d4',data_par%d_hy)
           call from_param('d5',d_freq)
!           call to_history('d5',d_freq)
           call from_param('o4',data_par%hy_0,0.)
!           call to_history('o4',data_par%hy_0)
           call from_param('o5',freq_0,0.)
!           call to_history('o5',freq_0)
        else
           call from_param('n5',data_par%n_hy)
!           call to_history('n5',data_par%n_hy)
           call from_param('n4',n_freq)
!           call to_history('n4',n_freq)
           call from_param('d5',data_par%d_hy)
!           call to_history('d5',data_par%d_hy)
           call from_param('d4',d_freq)
!           call to_history('d4',d_freq)
           call from_param('o5',data_par%hy_0,0.)
!           call to_history('o5',data_par%hy_0)
           call from_param('o4',freq_0,0.)
!           call to_history('o4',freq_0)
        end if
        call from_param('z_data_0',data_par%z_data_0)
        call to_history('z_data_0',data_par%z_data_0)
        if(gen_par%z_image_0 < data_par%z_data_0 ) then
           write(0,*)'gen_par%z_image_0=',gen_par%z_image_0
           write(0,*)'data_par%z_data_0=',data_par%z_data_0
           call seperr('z_image_0 < data_par-z_data_0')
        end if
        !}
     else
        !{
        if(gen_par%no_data) then
           !{
           data_par%data_file=DATA_NO_FILE
           call from_param('n1',data_par%n_mx)
!           call to_history('n1',data_par%n_mx)
           call from_param('n2',data_par%n_my)
!           call to_history('n2',data_par%n_my)
           call from_param('n3',data_par%n_hx)
!           call to_history('n3',data_par%n_hx)
           call from_param('d1',data_par%d_mx)
!           call to_history('d1',data_par%d_mx)
           call from_param('d2',data_par%d_my)
!           call to_history('d2',data_par%d_my)
           call from_param('d3',data_par%d_hx)
!           call to_history('d3',data_par%d_hx)
           call from_param('o1',data_par%mx_0,0.)
!           call to_history('o1',data_par%mx_0)
           call from_param('o2',data_par%my_0,0.)
!           call to_history('o2',data_par%my_0)
           call from_param('o3',data_par%hx_0,0.)
!           call to_history('o3',data_par%hx_0)
           if(gen_par%n_data_dim >4) then 
              call from_param('n4',data_par%n_hy)
!              call to_history('n4',data_par%n_hy)
              call from_param('n5',n_freq)
!              call to_history('n5',n_freq)
              call from_param('d4',data_par%d_hy)
!              call to_history('d4',data_par%d_hy)
              call from_param('d5',d_freq)
!              call to_history('d5',d_freq)
              call from_param('o4',data_par%hy_0,0.)
!              call to_history('o4',data_par%hy_0)
              call from_param('o5',freq_0,0.)
!              call to_history('o5',freq_0)
           else
              call from_param('n5',data_par%n_hy)
!              call to_history('n5',data_par%n_hy)
              call from_param('n4',n_freq)
!              call to_history('n4',n_freq)
              call from_param('d5',data_par%d_hy)
!              call to_history('d5',data_par%d_hy)
              call from_param('d4',d_freq)
!              call to_history('d4',d_freq)
              call from_param('o5',data_par%hy_0,0.)
!              call to_history('o5',data_par%hy_0)
              call from_param('o4',freq_0,0.)
!              call to_history('o4',freq_0)
           end if
           call from_param('z_data_0',data_par%z_data_0)
!           call to_history('z_data_0',data_par%z_data_0)
           if(gen_par%z_image_0 < data_par%z_data_0 ) then
              write(0,*)'gen_par%z_image_0=',gen_par%z_image_0
              write(0,*)'data_par%z_data_0=',data_par%z_data_0
              call seperr('z_image_0 < data_par-z_data_0')
           end if
           !}
        else
           !{
           ierr=auxinout('Data')
           data_par%data_file=DATA_INPUT
           call from_aux('Data',"esize",esize)
           call from_aux('Data',"n1",data_par%n_mx)
           call from_aux('Data',"n2",data_par%n_my)
           call from_aux('Data',"n3",data_par%n_hx)
           call from_aux('Data',"d1",data_par%d_mx)
           call from_aux('Data',"d2",data_par%d_my)
           call from_aux('Data',"d3",data_par%d_hx)
           call from_aux('Data',"o1",data_par%mx_0,0.)
           call from_aux('Data',"o2",data_par%my_0,0.)
           call from_aux('Data',"o3",data_par%hx_0,0.)
           if(gen_par%n_data_dim >4) then 
              call from_aux('Data',"n4",data_par%n_hy)
              call from_aux('Data',"n5",n_freq)
              call from_aux('Data',"d4",data_par%d_hy)
              call from_aux('Data',"d5",d_freq)
              call from_aux('Data',"o4",data_par%hy_0,0.)
              call from_aux('Data',"o5",freq_0,0.)
           else
              call from_aux('Data',"n5",data_par%n_hy,1)
              call from_aux('Data',"n4",n_freq)
              call from_aux('Data',"d5",data_par%d_hy,1.)
              call from_aux('Data',"d4",d_freq)
              call from_aux('Data',"o5",data_par%hy_0,0.)
              call from_aux('Data',"o4",freq_0,0.)
           end if
           if(gen_par%time_mig) then
             call from_aux('Data',"t_data_0",data_par%t_data_0)
             call to_history("From Data: t_data_0",data_par%t_data_0)
           else
!             call from_aux('Data',"z_data_0",data_par%z_data_0)
             call from_aux('Data',"z_data_0",data_par%z_data_0,0.)
             call to_history("From Data: z_data_0",data_par%z_data_0)
           end if

           if(esize /= data_par%esize_data) call seperr('Data must be complex')
           if(gen_par%z_image_0 < data_par%z_data_0 ) then
              write(0,*)'gen_par%z_image_0=',gen_par%z_image_0
              write(0,*)'data_par%z_data_0=',data_par%z_data_0
              call seperr('z_image_0 < data_par-z_data_0')
           end if
           !}
        end if
        !}
     end if
     if(gen_par%debug1) write(0,*)'data_file=',data_par%data_file
     !}
  end if

  if (auxin('Ddata') .gt. 0) then
     !{
     data_par%ddata_file=DATA_INPUT
     if ((gen_par%oper_type(1:1) == 'd').and. gen_par%first_adj) then
        !{
        call from_aux('Ddata',"esize",esize)
        call from_aux('Ddata',"n1",n1)
        call from_aux('Ddata',"n2",n2)
        call from_aux('Ddata',"n3",n3)
        call from_aux('Ddata',"n4",n4)
        call from_aux('Ddata',"n5",n5)

        call from_aux('Ddata',"d1",d1)
        call from_aux('Ddata',"d2",d2)
        call from_aux('Ddata',"d3",d3)
        call from_aux('Ddata',"d4",d4)
        call from_aux('Ddata',"d5",d5)

        call from_aux('Ddata',"o1",o1)
        call from_aux('Ddata',"o2",o2)
        call from_aux('Ddata',"o3",o3)
        call from_aux('Ddata',"o4",o4)
        call from_aux('Ddata',"o5",o5)

        if(gen_par%time_mig) then
          call from_aux('Ddata',"t_data_0",data_par%t_data_0)
          call to_history("From Data: t_data_0",data_par%t_data_0)
        else
          call from_aux('Ddata',"z_data_0",data_par%z_data_0)
          call to_history("From Data: z_data_0",data_par%z_data_0)
        end if
        if(esize /= data_par%esize_ddata) call seperr('Ddata must be complex')
        if(n1 /= data_par%n_mx ) call seperr('Ddata is unconsistent with Data')
        if(n2 /= data_par%n_my ) call seperr('Ddata is unconsistent with Data')
        if(n3 /= data_par%n_hx ) call seperr('Ddata is unconsistent with Data')
        if(d1 /= data_par%d_mx ) call seperr('Ddata is unconsistent with Data')
        if(d2 /= data_par%d_my ) call seperr('Ddata is unconsistent with Data')
        if(d3 /= data_par%d_hx ) call seperr('Ddata is unconsistent with Data')
        if(o1 /= data_par%mx_0 ) call seperr('Ddata is unconsistent with Data')
        if(o2 /= data_par%my_0 ) call seperr('Ddata is unconsistent with Data')
        if(o3 /= data_par%hx_0 ) call seperr('Ddata is unconsistent with Data')
        if(gen_par%n_data_dim >4) then 
           if(n4 /= data_par%n_hy ) call seperr('Ddata is unconsistent with Data')
           if(n5 /= n_freq ) call seperr('Ddata is unconsistent with Data')
           if(d4 /= data_par%d_hy ) call seperr('Ddata is unconsistent with Data')
           if(d5 /= d_freq ) call seperr('Ddata is unconsistent with Data')
           if(o4 /= data_par%hy_0 ) call seperr('Ddata is unconsistent with Data')
           if(o5 /= freq_0 ) call seperr('Ddata is unconsistent with Data')
        else
           if(n4 /= n_freq ) call seperr('Ddata is unconsistent with Data')
           if(n5 /= data_par%n_hy ) call seperr('Ddata is unconsistent with Data')
           if(d4 /= d_freq ) call seperr('Ddata is unconsistent with Data')
           if(d5 /= data_par%d_hy ) call seperr('Ddata is unconsistent with Data')
           if(o4 /= freq_0 ) call seperr('Ddata is unconsistent with Data')
           if(o5 /= data_par%hy_0 ) call seperr('Ddata is unconsistent with Data')
        end if

        if(gen_par%time_mig) then
           if(t0 /= data_par%t_data_0 ) then
             call seperr('t_data_0 in Ddata is unconsistent with Data')
           end if
        else
           if(z0 /= data_par%z_data_0 ) then
             call seperr('z_data_0 in Ddata is unconsistent with Data')
           end if
        end if
        if(gen_par%z_image_0 < data_par%z_data_0 ) then
           write(0,*)'gen_par%z_image_0=',gen_par%z_image_0
           write(0,*)'data_par%z_data_0=',data_par%z_data_0
           call seperr('z_image_0 < data_par-z_data_0')
        end if
        !}
     else
        !{
        call seperr('Cannot do anything with Ddata')
        !}
     end if
     !}
  end if
  if(gen_par%debug1) write(0,*)'ddata_file=',data_par%ddata_file

  if((gen_par%n_mx_pad > 0).and. (gen_par%n_mx_pad > data_par%n_mx)) then
     data_par%n_mx_pad=gen_par%n_mx_pad
     if(mod((data_par%n_mx_pad-data_par%n_mx),2) /= 0) &
        call seperr('Amount of padding along mx must be even')
     data_par%mx_0_pad=data_par%mx_0- &
       (int(data_par%n_mx_pad-data_par%n_mx)/2)*data_par%d_mx
  else
     data_par%n_mx_pad=data_par%n_mx
     data_par%mx_0_pad=data_par%mx_0
  end if
  if(gen_par%debug2) write(0,*)'data_par%mx_0_pad=',data_par%mx_0_pad


  if((gen_par%n_my_pad > 0).and. (gen_par%n_my_pad > data_par%n_my)) then
     data_par%n_my_pad=gen_par%n_my_pad
     if(mod((data_par%n_my_pad-data_par%n_my),2) /= 0) &
        call seperr('Amount of padding along my must be even')
     data_par%my_0_pad=data_par%my_0- &
       (int(data_par%n_my_pad-data_par%n_my)/2)*data_par%d_my
  else
     data_par%n_my_pad=data_par%n_my
     data_par%my_0_pad=data_par%my_0
  end if
  if(gen_par%debug2) write(0,*)'data_par%my_0_pad=',data_par%my_0_pad

  if((gen_par%n_hx_pad > 0).and. (gen_par%n_hx_pad > data_par%n_hx)) then
     data_par%n_hx_pad=gen_par%n_hx_pad
     if(gen_par%i_hx_0_shift_start /= i_hx_0_shift_start_init) &
        call seperr('No padding along hx allowed when hx_0_shift_start')
     if(gen_par%n_hx_0_shift_period /= n_hx_0_shift_period_init) &
        call seperr('No padding along hx allowed when hx_0_shift_period')
!     if(mod((data_par%n_hx_pad-data_par%n_hx),2) /= 0) &
!        call seperr('Amount of padding along hx must be even')
     data_par%hx_0_pad=data_par%hx_0- &
       (int(data_par%n_hx_pad-data_par%n_hx)/2)*data_par%d_hx
  else
     data_par%n_hx_pad=data_par%n_hx
     data_par%hx_0_pad=data_par%hx_0
  end if
  if(gen_par%debug2) write(0,*)'data_par%hx_0_pad=',data_par%hx_0_pad

  if((gen_par%n_hy_pad > 0).and. (gen_par%n_hy_pad > data_par%n_hy)) then
     data_par%n_hy_pad=gen_par%n_hy_pad
!     if(mod((data_par%n_hy_pad-data_par%n_hy),2) /= 0) &
!        call seperr('Amount of padding along hy must be even')
     data_par%hy_0_pad=data_par%hy_0- &
       (int(data_par%n_hy_pad-data_par%n_hy)/2)*data_par%d_hy
  else
     data_par%n_hy_pad=data_par%n_hy
     data_par%hy_0_pad=data_par%hy_0
  end if
  if(gen_par%debug2) write(0,*)'data_par%hy_0_pad=',data_par%hy_0_pad

  data_par%down_data_file=DATA_NO_FILE
  call from_param('write_down_data',write_down_data,.false.)
!  call to_history('write_down_data',write_down_data)
  if(write_down_data) then
    call from_param('write_down_data_pad', &
                    gen_par%write_down_data_pad,gen_par%write_down_data_pad)
    ierr=auxinout('Down_data')
    data_par%down_data_file=DATA_OUTPUT

    call to_history("esize",data_par%esize_data,'Down_data')

    if(gen_par%write_down_data_pad) then
      call to_history("n1",data_par%n_mx_pad,'Down_data')
      call to_history("n2",data_par%n_my_pad,'Down_data')
      call to_history("n3",data_par%n_hx_pad,'Down_data')
      call to_history("o1",data_par%mx_0_pad,'Down_data')
      call to_history("o2",data_par%my_0_pad,'Down_data')
      call to_history("o3",data_par%hx_0_pad,'Down_data')
      call to_history("d1",data_par%d_mx,'Down_data')
      call to_history("d2",data_par%d_my,'Down_data')
      call to_history("d3",data_par%d_hx,'Down_data')
      if(gen_par%n_data_dim >4) then  
         call to_history("n4",data_par%n_hy_pad,'Down_data')
         call to_history("n5",n_freq,'Down_data')
         call to_history("o4",data_par%hy_0_pad,'Down_data')
         call to_history("o5",freq_0,'Down_data')
         call to_history("d4",data_par%d_hy,'Down_data')
         call to_history("d5",d_freq,'Down_data')
      else
         call to_history("n5",data_par%n_hy_pad,'Down_data')
         call to_history("n4",n_freq,'Down_data')
         call to_history("o5",data_par%hy_0_pad,'Down_data')
         call to_history("o4",freq_0,'Down_data')
         call to_history("d5",data_par%d_hy,'Down_data')
         call to_history("d4",d_freq,'Down_data')
      end if
    else
      call to_history("n1",data_par%n_mx,'Down_data')
      call to_history("n2",data_par%n_my,'Down_data')
      call to_history("n3",data_par%n_hx,'Down_data')
      call to_history("o1",data_par%mx_0,'Down_data')
      call to_history("o2",data_par%my_0,'Down_data')
      call to_history("o3",data_par%hx_0,'Down_data')
      call to_history("d1",data_par%d_mx,'Down_data')
      call to_history("d2",data_par%d_my,'Down_data')
      call to_history("d3",data_par%d_hx,'Down_data')
      if(gen_par%n_data_dim >4) then  
         call to_history("n4",data_par%n_hy,'Down_data')
         call to_history("n5",n_freq,'Down_data')
         call to_history("o4",data_par%hy_0,'Down_data')
         call to_history("o5",freq_0,'Down_data')
         call to_history("d4",data_par%d_hy,'Down_data')
         call to_history("d5",d_freq,'Down_data')
      else
         call to_history("n5",data_par%n_hy,'Down_data')
         call to_history("n4",n_freq,'Down_data')
         call to_history("o5",data_par%hy_0,'Down_data')
         call to_history("o4",freq_0,'Down_data')
         call to_history("d5",data_par%d_hy,'Down_data')
         call to_history("d4",d_freq,'Down_data')
      end if
    end if
    new_z_data_0=gen_par%z_image_0 + (gen_par%n_z_image)*gen_par%d_z_image
    call to_history("z_data_0",new_z_data_0,'Down_data')
  end if
  if(gen_par%debug1) write(0,*)'down_data_file=',data_par%down_data_file

  data_par%down_ddata_file=DATA_NO_FILE
  call from_param('write_down_ddata',write_down_ddata,.false.)
!  call to_history('write_down_ddata',write_down_ddata)
  if (gen_par%oper_type(1:1) == 'd') then
     !{
     if(write_down_ddata) then
        ierr=auxinout('Down_ddata')
        data_par%down_ddata_file=DATA_OUTPUT
        call to_history("esize",data_par%esize_ddata,'Down_ddata')
        call to_history("n1",data_par%n_mx,'Down_ddata')
        call to_history("n2",data_par%n_my,'Down_ddata')
        call to_history("n3",data_par%n_hx,'Down_ddata')
        call to_history("d1",data_par%d_mx,'Down_ddata')
        call to_history("d2",data_par%d_my,'Down_ddata')
        call to_history("d3",data_par%d_hx,'Down_ddata')
        call to_history("o1",data_par%mx_0,'Down_ddata')
        call to_history("o2",data_par%my_0,'Down_ddata')
        call to_history("o3",data_par%hx_0,'Down_ddata')
        if(gen_par%n_data_dim >4) then  
           call to_history("n4",data_par%n_hy,'Down_ddata')
           call to_history("n5",n_freq,'Down_ddata')
           call to_history("d4",data_par%d_hy,'Down_ddata')
           call to_history("d5",d_freq,'Down_ddata')
           call to_history("o4",data_par%hy_0,'Down_ddata')
           call to_history("o5",freq_0,'Down_ddata')
        else
           call to_history("n5",data_par%n_hy,'Down_ddata')
           call to_history("n4",n_freq,'Down_ddata')
           call to_history("d5",data_par%d_hy,'Down_ddata')
           call to_history("d4",d_freq,'Down_ddata')
           call to_history("o5",data_par%hy_0,'Down_ddata')
           call to_history("o4",freq_0,'Down_ddata')
        end if
        new_z_data_0=gen_par%z_image_0 + (gen_par%n_z_image)*gen_par%d_z_image
        call to_history("z_data_0",new_z_data_0,'Down_ddata')
     end if
     !}
  else
     !{
     if(write_down_ddata) then
        call seperr('Cannot write Down_ddata because it is not computed')
     end if
     !}
  end if
  if(gen_par%debug1) write(0,*)'down_ddata_file=',data_par%down_ddata_file

  if(data_par%d_mx == 0) call seperr('Data d_mx cannot be equal to zero')
  if(data_par%d_my == 0) call seperr('Data d_my cannot be equal to zero')
  if(data_par%d_hx == 0) call seperr('Data d_hx cannot be equal to zero')
  if(data_par%d_hy == 0) call seperr('Data d_hy cannot be equal to zero')

  pi=acos(-1.)
  data_par%n_w=n_freq
  data_par%w_0=2.*pi*freq_0
  data_par%khx_0=0.
  data_par%khy_0=0.
  data_par%kmx_0=0.
  data_par%kmy_0=0.
  data_par%d_w=2.*pi*d_freq
  data_par%d_khx=2.*pi/(data_par%d_hx*FLOAT(data_par%n_hx_pad))
  data_par%d_khy=2.*pi/(data_par%d_hy*FLOAT(data_par%n_hy_pad))
  data_par%d_kmx=2.*pi/(data_par%d_mx*FLOAT(data_par%n_mx_pad))
  data_par%d_kmy=2.*pi/(data_par%d_my*FLOAT(data_par%n_my_pad))
  return
end subroutine param_data

subroutine param_down(gen_par,data_par,image_par,down_par,slow_par)

  use sep
  use gendown3d_types
  use data_types
  use image_types
  use slow_types
  use down_process_types

  implicit none

  logical cra_p_for_px
  logical write_image,write_wavefield,read_wavefield
  type (gendown3d_param_type) gen_par
  type (data_param_type) data_par
  type (image_param_type) image_par
  type (down_process_param_type) down_par
  type (slow_param_type) slow_par
  integer, external :: auxpar,getch,fetch,auxin,sreed,sseek,auxout,auxinout

  character(len=128) :: tag_name
  integer i_one,ierr
  integer n1,n2,n3,n4,n5,esize,n_z_wave
  integer n1_image,n2_image,n3_image,n4_image,n5_image
  integer n_z_slow,n_mx_slow,n_my_slow
  integer i_w_min_0,i_w_max_0,i_w_min_1,i_w_max_1
  real d1,d2,d3,d4,d5,o1,o2,o3,o4,o5,z0,d_z_wave
  real o1_image,o2_image,o3_image,o4_image,o5_image
  real d1_image,d2_image,d3_image,d4_image,d5_image
  real z_slow_0,d_z_slow,mx_slow_0,d_mx_slow,my_slow_0,d_my_slow

  real pi,nint_w_min_0
  integer int_nint_w_min_0

  i_one=1
  pi=acos(-1.)


  call from_param('read_wavefield',read_wavefield,.false.)
!  call to_history('read_wavefield',read_wavefield)
  call from_param('write_wavefield', write_wavefield,.false.)
!  call to_history('write_wavefield', write_wavefield)
  call from_param('write_image',write_image,.true.)
!  call to_history('write_image',write_image)

  ! down parameters
  if(gen_par%n_w_block == n_w_block_init) then
     gen_par%n_w_block=data_par%n_w
  end if

  down_par%n_w_block_par=gen_par%n_threads
  call from_param('n_w_block_par',down_par%n_w_block_par,down_par%n_w_block_par)
!  call to_history('n_w_block_par',down_par%n_w_block_par)
  if(down_par%n_w_block_par .ne. gen_par%n_threads) then
    call seperr('n_w_block_par != n_threads')
  end if

  if(down_par%n_w_block_par > gen_par%n_w_block) then
     call seperr('n_w_block_par > n_w_block')
  end if

  if(mod(gen_par%n_w_block,down_par%n_w_block_par) == 0)  then
     down_par%n_w_block_ser=gen_par%n_w_block/down_par%n_w_block_par
  else
     call seperr('n_w_block not multiple of n_w_block_par')
  end if
  !------------------

  if(gen_par%mx_spike_0 == mx_spike_0_init) then
     gen_par%mx_spike_0=data_par%mx_0+(data_par%n_mx/2)*data_par%d_mx
  end if
  if(gen_par%my_spike_0 == my_spike_0_init) then
     gen_par%my_spike_0=data_par%my_0+(data_par%n_my/2)*data_par%d_my
  end if
  if(gen_par%hx_spike_0 == hx_spike_0_init) then
     gen_par%hx_spike_0=data_par%hx_0+(data_par%n_hx/2)*data_par%d_hx
  end if
  if(gen_par%hy_spike_0 == hy_spike_0_init) then
     gen_par%hy_spike_0=data_par%hy_0+(data_par%n_hy/2)*data_par%d_hy
  end if
  if(gen_par%mx_spike_1 == mx_spike_1_init) then
     gen_par%mx_spike_1=data_par%mx_0+(data_par%n_mx/2)*data_par%d_mx
  end if
  if(gen_par%my_spike_1 == my_spike_1_init) then
     gen_par%my_spike_1=data_par%my_0+(data_par%n_my/2)*data_par%d_my
  end if
  if(gen_par%hx_spike_1 == hx_spike_1_init) then
     gen_par%hx_spike_1=data_par%hx_0+(data_par%n_hx/2)*data_par%d_hx
  end if
  if(gen_par%hy_spike_1 == hy_spike_1_init) then
     gen_par%hy_spike_1=data_par%hy_0+(data_par%n_hy/2)*data_par%d_hy
  end if

  down_par%spike_data= ((gen_par%t_spike_0 >= 0.).and. &
  (gen_par%hx_spike_0 >= data_par%hx_0).and. &
  (gen_par%hy_spike_0 >= data_par%hy_0).and. &
  (gen_par%mx_spike_0 >= data_par%mx_0).and. &
  (gen_par%my_spike_0 >= data_par%my_0))

  down_par%plane_data= ((gen_par%t_spike_0 >= 0.).and. &
  (gen_par%hx_spike_0 < data_par%hx_0).and. &
  (gen_par%hy_spike_0 < data_par%hy_0).and. &
  (gen_par%mx_spike_0 < data_par%mx_0).and. &
  (gen_par%my_spike_0 < data_par%my_0))

  down_par%diffr_data= ((gen_par%t_spike_0 >= 0.).and. &
  (gen_par%hx_spike_0 < data_par%hx_0).and. &
  (gen_par%hy_spike_0 < data_par%hy_0).and. &
  (gen_par%mx_spike_0 >= data_par%mx_0).and. &
  (gen_par%my_spike_0 >= data_par%my_0))

  if (data_par%data_file == DATA_INPUT) then
     down_par%spike_data= .false.
     down_par%plane_data= .false.
     down_par%diffr_data= .false.
  end if

  if(gen_par%debug1) write(0,*)'spike_data=',down_par%spike_data
  if(gen_par%debug1) write(0,*)'plane_data=',down_par%plane_data
  if(gen_par%debug1) write(0,*)'diffr_data=',down_par%diffr_data
  if(gen_par%debug1) write(0,*)'mx_spike_0=',gen_par%mx_spike_0
  if(gen_par%debug1) write(0,*)'my_spike_0=',gen_par%my_spike_0
  if(gen_par%debug1) write(0,*)'hx_spike_0=',gen_par%hx_spike_0
  if(gen_par%debug1) write(0,*)'hy_spike_0=',gen_par%hy_spike_0

  if(gen_par%n_z_block == n_z_block_init) then
     gen_par%n_z_block=1
     call to_history('Default n_z_block',gen_par%n_z_block)
  end if
  down_par%n_z_block=gen_par%n_z_block
  if(mod(gen_par%n_z_image,down_par%n_z_block) .ne. 0) then
    write(0,*)'n_z_image=',gen_par%n_z_image
    write(0,*)'n_z_block=',down_par%n_z_block
    call seperr('n_z_image not multiple of n_z_block')
  end if
    

  down_par%n_z_down=gen_par%n_z_image
  if(gen_par%first_adj) then
     down_par%d_z_down=-gen_par%d_z_image
     down_par%z_down_0= &
     gen_par%z_image_0 + (gen_par%n_z_image-1)*gen_par%d_z_image
  else
     down_par%d_z_down= gen_par%d_z_image
     down_par%z_down_0= gen_par%z_image_0
  end if

  ! image parameters
  call from_param('tag_image',image_par%tag_image,'Image')
!  call to_history('tag_image',image_par%tag_image)
  call from_param('tag_dimage',image_par%tag_dimage,'Dimage')
!  call to_history('tag_dimage',image_par%tag_dimage)

  ! find out what to do with image file
  if (((gen_par%first_adj) .and. (gen_par%domain_range(6:9) == 'imag')) .or. &
  ((gen_par%first_adj) .and. (gen_par%domain_range(7:11) == 'dimag') .and. &
  (.not. read_wavefield))) then
     image_par%image_file=IMAGE_INPUT
     if (auxinout('Image') <= 0) call seperr('Could not find file Image')
  else
     if(write_image) then
        image_par%image_file=IMAGE_OUTPUT
     else
        image_par%image_file=IMAGE_NO_FILE
     end if
  end if
  if(read_wavefield) then
     image_par%image_file=IMAGE_NO_FILE
  end if

  if(gen_par%debug1) write(0,*)'image_file=',image_par%image_file

  ! find out what to do with Dimage file
  if (gen_par%oper_type(1:1) == 'd') then
     if (.not. gen_par%first_adj) then
        image_par%dimage_file=IMAGE_OUTPUT
     else
        if (auxinout('Dimage') > 0) then
           if(data_par%ddata_file == DATA_INPUT) then
              call seperr('Given both Dimage and Ddata')
           end if
           image_par%dimage_file=IMAGE_INPUT
        else
           image_par%dimage_file=IMAGE_NO_FILE
           if(data_par%ddata_file /= DATA_INPUT) then
              call seperr('Needs either Dimage or Ddata')
           end if
        end if
     end if
  end if
  if(gen_par%debug1) write(0,*)'dimage_file=',image_par%dimage_file

  ! set the right geometry for images
  if(gen_par%complex_image) then
     image_par%esize_image=8
  else
     image_par%esize_image=4
  end if
  image_par%esize_dimage=8

  image_par%n_mx_image=data_par%n_mx_pad
  image_par%mx_image_0=data_par%mx_0_pad

  image_par%n_my_image=data_par%n_my_pad
  image_par%my_image_0=data_par%my_0_pad

  image_par%n_z_image=gen_par%n_z_image
  image_par%z_image_0=gen_par%z_image_0

  image_par%d_z_image=gen_par%d_z_image

  if(gen_par%image_zero_offset) then
     image_par%n_hx_image=1
     image_par%n_hy_image=1
     image_par%hx_image_0=0.
     image_par%hy_image_0=0.
     image_par%d_hx_image=1.
     image_par%d_hy_image=1.
  else

     if(gen_par%image_cig) then
        call from_param('n_px_image',image_par%n_px_image,data_par%n_hx_pad)
!        call to_history('n_px_image',image_par%n_px_image)
        call from_param('n_py_image',image_par%n_py_image,1)
!        call to_history('n_py_image',image_par%n_py_image)
        call from_param('d_px_image',image_par%d_px_image,data_par%d_hx)
!        call to_history('d_px_image',image_par%d_px_image)
        call from_param('d_py_image',image_par%d_py_image,data_par%d_hy)
!        call to_history('d_py_image',image_par%d_py_image)
        call from_param('px_image_0',image_par%px_image_0,0.)
!        call to_history('px_image_0',image_par%px_image_0)
        call from_param('py_image_0',image_par%py_image_0,0.)
!        call to_history('py_image_0',image_par%py_image_0)
        !+++
        call from_param('cra_p_for_px',cra_p_for_px,.false.)
!        call to_history('cra_p_for_px',cra_p_for_px)
        call from_param('cig_p_for_px',image_par%cig_p_for_px,.false.)
!        call to_history('cig_p_for_px',image_par%cig_p_for_px)

       if(image_par%cig_p_for_px .neqv. cra_p_for_px) then
         write(0,*)'cig_p_for_px and cra_p_for_px are different'
         write(0,*)'The use of cra_p_for_px is deprecated'
         call seperr('Please change cra_p_for_px into cig_p_for_px in your parameters')
       end if
        
        ! set this to allocate arrays with right dimensions
        !+++
        if(image_par%cig_p_for_px) then
           write(0,*)'Use real p norm for px'
           image_par%n_hx_image=image_par%n_px_image
           image_par%n_hy_image=1
        else
           write(0,*)'Use both px and py axes in output image'
           image_par%n_hx_image=image_par%n_px_image
           image_par%n_hy_image=image_par%n_py_image
        endif

     else

        image_par%n_hx_image=data_par%n_hx_pad
        image_par%hx_image_0=data_par%hx_0_pad
        image_par%d_hx_image=data_par%d_hx
!        image_par%n_hy_image=1
        image_par%n_hy_image=data_par%n_hy_pad
        image_par%hy_image_0=data_par%hy_0_pad
        image_par%d_hy_image=data_par%d_hy
     end if
  end if

  n1_image=image_par%n_mx_image
  o1_image=data_par%mx_0
  d1_image=data_par%d_mx
  n2_image=image_par%n_my_image
  o2_image=data_par%my_0
  d2_image=data_par%d_my
  if(gen_par%image_zero_offset) then
     n3_image=image_par%n_z_image
     o3_image=image_par%z_image_0
     d3_image=image_par%d_z_image
     n4_image=image_par%n_hx_image
     o4_image=image_par%hx_image_0
     d4_image=image_par%d_hx_image
     n5_image=image_par%n_hy_image
     o5_image=image_par%hy_image_0
     d5_image=image_par%d_hy_image
  else
     n4_image=image_par%n_z_image
     o4_image=image_par%z_image_0
     d4_image=image_par%d_z_image
     if(gen_par%image_cig) then
        n3_image=image_par%n_px_image
        o3_image=image_par%px_image_0
        d3_image=image_par%d_px_image
        n5_image=image_par%n_py_image
        o5_image=image_par%py_image_0
        d5_image=image_par%d_py_image
     else
        n3_image=image_par%n_hx_image
        o3_image=image_par%hx_image_0
        d3_image=image_par%d_hx_image
        n5_image=image_par%n_hy_image
        o5_image=image_par%hy_image_0
        d5_image=image_par%d_hy_image
     end if
  end if

  ! transformation from Image
  if (image_par%image_file == IMAGE_INPUT) then
     !{
     call from_aux('Image',"esize",esize)
     call from_aux('Image',"n1",n1)
     call from_aux('Image',"n2",n2)
     call from_aux('Image',"n3",n3)
     call from_aux('Image',"n4",n4)
     call from_aux('Image',"n5",n5)

     call from_aux('Image',"d1",d1)
     call from_aux('Image',"d2",d2)
     call from_aux('Image',"d3",d3)
     call from_aux('Image',"d4",d4)
     call from_aux('Image',"d5",d5)

     call from_aux('Image',"o1",o1)
     call from_aux('Image',"o2",o2)
     call from_aux('Image',"o3",o3)
     call from_aux('Image',"o4",o4)
     call from_aux('Image',"o5",o5)
     if(.not.gen_par%image_zero_offset) then
        call from_aux('Image',"n5",n5)
        call from_aux('Image',"o5",o5)
        call from_aux('Image',"d5",d5)
     end if

     if(esize /= image_par%esize_image) call seperr('Image of wrong type')
     if(n1 /= n1_image ) call seperr('Image n1 is uncons. with Data')
     if(n2 /= n2_image ) call seperr('Image n2 is uncons. with Data')

     if(d1 /= d1_image ) call seperr('Image d1 is unconsis. with Data')
     if(d2 /= d2_image ) call seperr('Image d2 is unconsis. with Data')

     if(o1 /= o1_image ) call seperr('Image o1 is unconsis. with Data')
     if(o2 /= o2_image ) call seperr('Image o2 is unconsis. with Data')

     if(gen_par%image_zero_offset .or. (.not. gen_par%image_cig)) then
        if(n3 /= n3_image ) call seperr('Image n3 is uncons. with Data')
        if(d3 /= d3_image ) call seperr('Image d3 is uncons. with Data')
        if(o3 /= o3_image ) call seperr('Image o3 is uncons. with Data')
     end if

     if(.not.gen_par%image_zero_offset) then
        if(n4 /= n4_image ) call seperr('Image n4 is uncons. with Data')
        if(d4 /= d4_image ) call seperr('Image d4 is unconsis. with Data')
        if(o4 /= o4_image ) call seperr('Image o4 is unconsis. with Data')
        if(n5 /= n5_image ) call seperr('Image n5 is unconsis. with Data')
        if(d5 /= d5_image ) call seperr('Image d5 is unconsis. with Data')
        if(o5 /= o5_image ) call seperr('Image o5 is unconsis. with Data')
     end if
     !}
  else
     !{
     if(image_par%image_file == IMAGE_OUTPUT) then
        !{
        ierr=auxinout('Image')
        call to_history("esize",image_par%esize_image,'Image')
        call to_history("n1",n1_image,'Image')
        call to_history("n2",n2_image,'Image')
        call to_history("n3",n3_image,'Image')
        call to_history("n4",n4_image,'Image')
        call to_history("n5",n5_image,'Image')
        call to_history("d1",d1_image,'Image')
        call to_history("d2",d2_image,'Image')
        call to_history("d3",d3_image,'Image')
        call to_history("d4",d4_image,'Image')
        call to_history("d5",d5_image,'Image')
        call to_history("o1",o1_image,'Image')
        call to_history("o2",o2_image,'Image')
        call to_history("o3",o3_image,'Image')
        call to_history("o4",o4_image,'Image')
        call to_history("o5",o5_image,'Image')
        !}
     end if
     !}
  end if

  ! transformation from Dimage
  if (image_par%dimage_file == IMAGE_INPUT) then
     !{
     call from_aux('Dimage',"esize",esize)
     call from_aux('Dimage',"n1",n1)
     call from_aux('Dimage',"n2",n2)
     call from_aux('Dimage',"n3",n3)
     call from_aux('Dimage',"n4",n4)
     call from_aux('Dimage',"n5",n5)

     call from_aux('Dimage',"d1",d1)
     call from_aux('Dimage',"d2",d2)
     call from_aux('Dimage',"d3",d3)
     call from_aux('Dimage',"d4",d4)
     call from_aux('Dimage',"d5",d5)

     call from_aux('Dimage',"o1",o1)
     call from_aux('Dimage',"o2",o2)
     call from_aux('Dimage',"o3",o3)
     call from_aux('Dimage',"o4",o4)
     call from_aux('Dimage',"o5",o5)

     if(esize /= image_par%esize_dimage) call seperr('Dimage of wrong type')
     if(n1 /= n1_image ) call seperr('Dimage n1 is uncons. with Data')
     if(n2 /= n2_image ) call seperr('Dimage n2 is uncons. with Data')

     if(d1 /= d1_image ) call seperr('Dimage d1 is unconsis. with Data')
     if(d2 /= d2_image ) call seperr('Dimage d2 is unconsis. with Data')

     if(o1 /= o1_image ) call seperr('Dimage o1 is unconsis. with Data')
     if(o2 /= o2_image ) call seperr('Dimage o2 is unconsis. with Data')

     if(gen_par%image_zero_offset .or. (.not. gen_par%image_cig)) then
        if(n3 /= n3_image ) call seperr('Dimage n3 is uncons. with Data')
        if(d3 /= d3_image ) call seperr('Dimage d3 is uncons. with Data')
        if(o3 /= o3_image ) call seperr('Dimage o3 is uncons. with Data')
     end if
     if(.not.gen_par%image_zero_offset) then
        if(n4 /= n4_image ) call seperr('Dimage n4 is uncons. with Data')
        if(n5 /= n5_image ) call seperr('Dimage n5 is unconsis. with Data')
        if(d4 /= d4_image ) call seperr('Dimage d4 is unconsis. with Data')
        if(d5 /= d5_image ) call seperr('Dimage d5 is unconsis. with Data')
        if(o4 /= o4_image ) call seperr('Dimage o4 is unconsis. with Data')
        if(o5 /= o5_image ) call seperr('Dimage o5 is unconsis. with Data')
     end if
     !}
  else
     !{
     if(image_par%dimage_file == IMAGE_OUTPUT) then
        !{
        ierr=auxinout('Dimage')
        call to_history("esize",image_par%esize_dimage,'Dimage')
        call to_history("n1",n1_image,'Dimage')
        call to_history("n2",n2_image,'Dimage')
        call to_history("n3",n3_image,'Dimage')
        call to_history("n4",n4_image,'Dimage')
        call to_history("n5",n5_image,'Dimage')

        call to_history("d1",d1_image,'Dimage')
        call to_history("d2",d2_image,'Dimage')
        call to_history("d3",d3_image,'Dimage')
        call to_history("d4",d4_image,'Dimage')
        call to_history("d5",d5_image,'Dimage')

        call to_history("o1",o1_image,'Dimage')
        call to_history("o2",o2_image,'Dimage')
        call to_history("o3",o3_image,'Dimage')
        call to_history("o4",o4_image,'Dimage')
        call to_history("o5",o5_image,'Dimage')
        !}
     end if
     !}
  end if

  if((gen_par%freq_min_amp .ne. freq_min_amp_init ) .and. &
     (gen_par%freq_max_amp .ne. freq_max_amp_init )) then
    image_par%w_min_amp=2.*pi*gen_par%freq_min_amp
    image_par%w_max_amp=2.*pi*gen_par%freq_max_amp
  else
    image_par%w_min_amp=-1.
    image_par%w_max_amp=-1.
  end if

  ! wavefield parameters
  data_par%wavefield_file=DATA_NO_FILE
  if(write_wavefield) then
     !{
     data_par%wavefield_file=DATA_OUTPUT
     ierr=auxinout(trim(data_par%tag_wavefield))
     n_z_wave=down_par%n_z_down/down_par%n_z_block
     d_z_wave=down_par%n_z_block*down_par%d_z_down
     if(down_par%n_z_block /= 1) then
        write(0,*)'WARNING: Not recording wavefield at each depth step'
!        call seperr('Not working properly yet')
     end if
     call to_history("esize",data_par%esize_wavefield,'Wavefield')
     call to_history("n1",data_par%n_mx,'Wavefield')
     call to_history("n2",data_par%n_my,'Wavefield')
     call to_history("n3",data_par%n_hx,'Wavefield')
     call to_history("n4",data_par%n_w,'Wavefield')
     call to_history("n5",n_z_wave,'Wavefield')

     call to_history("d1",data_par%d_mx,'Wavefield')
     call to_history("d2",data_par%d_my,'Wavefield')
     call to_history("d3",data_par%d_hx,'Wavefield')
     call to_history("d4",data_par%d_w,'Wavefield')
     call to_history("d5",d_z_wave,'Wavefield')

     call to_history("o1",data_par%mx_0,'Wavefield')
     call to_history("o2",data_par%my_0,'Wavefield')
     call to_history("o3",data_par%hx_0,'Wavefield')
     call to_history("o4",data_par%w_0,'Wavefield')
     call to_history("o5",gen_par%z_image_0,'Wavefield')
     !}
  end if
  if(read_wavefield) then
     !{
     if(write_wavefield) call seperr('Either read or write wavefield')
     data_par%wavefield_file=DATA_INPUT
     if (auxinout(trim(data_par%tag_wavefield)) <= 0) then
        call seperr('Cannot find file Wavefield')
     end if
     n_z_wave=down_par%n_z_down/down_par%n_z_block
     d_z_wave=down_par%n_z_block*abs(down_par%d_z_down)
     if(down_par%n_z_block /= 1) then
        write(0,*)'WARNING: Not reading wavefield at each depth step'
        call seperr('Not working properly yet')
     end if

     call from_aux('Wavefield',"esize",esize)

     call from_aux('Wavefield',"n1",n1)
     call from_aux('Wavefield',"n2",n2)
     call from_aux('Wavefield',"n3",n3)
     call from_aux('Wavefield',"n4",n4)
     call from_aux('Wavefield',"n5",n5)

     call from_aux('Wavefield',"d1",d1)
     call from_aux('Wavefield',"d2",d2)
     call from_aux('Wavefield',"d3",d3)
     call from_aux('Wavefield',"d4",d4)
     call from_aux('Wavefield',"d5",d5)

     call from_aux('Wavefield',"o1",o1)
     call from_aux('Wavefield',"o2",o2)
     call from_aux('Wavefield',"o3",o3)
     call from_aux('Wavefield',"o4",o4)
     call from_aux('Wavefield',"o5",o5)

     if(esize /= data_par%esize_wavefield ) call seperr('esize wrong in Wavefield')
     if(n1 /= data_par%n_mx ) call seperr('n1 wrong in Wavefield')
     if(n2 /= data_par%n_my ) call seperr('n2 wrong in Wavefield')
     if(n3 /= data_par%n_hx ) call seperr('n3 wrong in Wavefield')
     if(n4 /= data_par%n_w ) call seperr('n4 wrong in Wavefield')
     if(n5 /= n_z_wave ) call seperr('n5 wrong in Wavefield')
     if(d1 /= data_par%d_mx ) call seperr('d1 wrong in Wavefield')
     if(d2 /= data_par%d_my ) call seperr('d2 wrong in Wavefield')
     if(d3 /= data_par%d_hx) call seperr('d3 wrong in Wavefield')
     if(abs(d4-data_par%d_w)>1000.*epsilon(d4))call seperr('d4 wrong in Wavefield')
     if(abs(d5-d_z_wave)>1000.*epsilon(d5)) call seperr('d5 wrong in Wavefield')
     if(o1 /= data_par%mx_0 ) call seperr('o1 wrong in Wavefield')
     if(o2 /= data_par%my_0 ) call seperr('o2 wrong in Wavefield')
     if(o3 /= data_par%hx_0) call seperr('o3 wrong in Wavefield')
     !write(0,*)abs(o4-data_par%w_0),epsilon(o4)
     if(abs(o4-data_par%w_0)>1000.*epsilon(o4))call seperr('o4 wrong in Wavefield')
     if(o5 /= gen_par%z_image_0) call seperr('o5 wrong in Wavefield')
     !}
  end if
  if(gen_par%debug1) write(0,*)'wavefield_file=',data_par%wavefield_file

  ! slow parameters
  call from_param('tag_slow',slow_par%tag_slow,'Slow')
!  call to_history('tag_slow',slow_par%tag_slow)
  call from_param(trim(slow_par%tag_slow),tag_name,'Slow not found')
!  call to_history('Slow_history',tag_name)
   slow_par%tag_slow=trim(slow_par%tag_slow)

  call from_param('tag_slow_shear',slow_par%tag_slow_shear,'Slow_shear')
!  call to_history('tag_slow',slow_par%tag_slow)
  call from_param(trim(slow_par%tag_slow_shear),tag_name,'Slow_shear not found')
!  call to_history('Slow_history',tag_name)
   slow_par%tag_slow_shear=trim(slow_par%tag_slow_shear)

  call from_param('tag_dslow',slow_par%tag_dslow,'Dslow')
!  call to_history('tag_dslow',slow_par%tag_dslow)
  call from_param(trim(slow_par%tag_dslow),tag_name,'Dslow not found')
!  call to_history('Dslow_history',tag_name)

  slow_par%esize_slow=4
  slow_par%esize_slow_shear=4
  slow_par%esize_dslow=8
  slow_par%slow_scale=gen_par%slow_scale

  if((data_par%n_hx_pad /= 1) .or. (data_par%n_hy_pad /= 1)) then
     slow_par%n_comp_slow=2
  else
     slow_par%n_comp_slow=1 
  end if

  if (auxin('Slow') .gt. 0) then
     !{
     slow_par%slow_file=SLOW_INPUT
     call from_param('slowness',slow_par%slowness,.true.)
!     call to_history('slowness',slow_par%slowness)
     call from_param('extrapolate_slow',slow_par%extrapolate_slow,.false.)
!     call to_history('extrapolate_slow',slow_par%extrapolate_slow)

     call from_aux('Slow',"esize",esize)
     call from_aux('Slow',"n1",slow_par%n_mx_slow)
     call to_history("From Slow: n1",slow_par%n_mx_slow)
     call from_aux('Slow',"o1",slow_par%mx_slow_0)
     call to_history("From Slow: o1",slow_par%mx_slow_0)
     call from_aux('Slow',"d1",slow_par%d_mx_slow)
     call to_history("From Slow: d1",slow_par%d_mx_slow)

     call from_aux('Slow',"n2",slow_par%n_my_slow)
     call to_history("From Slow: n2",slow_par%n_my_slow)
     call from_aux('Slow',"o2",slow_par%my_slow_0)
     call to_history("From Slow: o2",slow_par%my_slow_0)
     call from_aux('Slow',"d2",slow_par%d_my_slow)
     call to_history("From Slow: d2",slow_par%d_my_slow)

     call from_aux('Slow',"n3",slow_par%n_z_slow,1)
     call to_history("From Slow: n3",slow_par%n_z_slow)
     call from_aux('Slow',"o3",slow_par%z_slow_0,0.)
     call to_history("From Slow: o3",slow_par%z_slow_0)
     call from_aux('Slow',"d3",slow_par%d_z_slow,1.)
     call to_history("From Slow: d3",slow_par%d_z_slow)

     if(esize /= slow_par%esize_slow) call seperr('Slow must be real')
     if(slow_par%z_slow_0 .gt. gen_par%z_image_0) then
        call seperr('z_slow_0 > gen_par%z_image_0 ')
     end if
     if((amod(image_par%z_image_0-slow_par%z_slow_0,slow_par%d_z_slow)) > &
            100*epsilon(slow_par%d_z_slow) .and. &
        (amod(image_par%z_image_0-slow_par%z_slow_0,slow_par%d_z_slow)) < &
            slow_par%d_z_slow-100*epsilon(slow_par%d_z_slow)) then
        write(0,*)'image_par%z_image_0=',image_par%z_image_0
        write(0,*)'slow_par%z_slow_0=',slow_par%z_slow_0
        write(0,*)'slow_par%d_z_slow=',slow_par%d_z_slow
        write(0,*)'amod=', &
          amod(image_par%z_image_0-slow_par%z_slow_0,slow_par%d_z_slow)
        call seperr('z_image_0-z_slow_0 not multiple of d_z_slow')
     end if

     if(amod(slow_par%d_z_slow,abs(image_par%d_z_image)) .ne. 0.) then
        write(0,*)'d_z_down=',image_par%d_z_image
        write(0,*)'abs(d_z_down)=',abs(image_par%d_z_image)
        write(0,*)'d_z_slow=',slow_par%d_z_slow
        call seperr('d_z_slow not multiple of d_z_image ')
     end if
!     if(abs(amod(down_par%n_z_block*image_par%d_z_image,slow_par%d_z_slow))>epsilon(slow_par%d_z_slow)*10.*down_par%n_z_block) then
!        write(0,*)'d_z_image=',image_par%d_z_image
!        write(0,*)'d_z_slow=',slow_par%d_z_slow
!        call seperr('down-n_z_block*image-d_z_image not multiple slow-d_z_slow')
!     end if

     if((slow_par%z_slow_0+(slow_par%n_z_slow-1)*slow_par%d_z_slow) < &
        (image_par%z_image_0 +(image_par%n_z_image-1)*image_par%d_z_image))then
        write(0,*)'image_par%z_image_0=',image_par%z_image_0
        write(0,*)'image_par%n_z_image=',image_par%n_z_image
        write(0,*)'image_par%d_z_image=',image_par%d_z_image
        write(0,*)'slow_par%z_slow_0=',slow_par%z_slow_0
        write(0,*)'slow_par%n_z_slow=',slow_par%n_z_slow
        write(0,*)'slow_par%d_z_slow=',slow_par%d_z_slow
        call seperr('image is deeper than velocity function')
     endif
     !}
  else 
     !{
     slow_par%slow_file=SLOW_NO_FILE
     if(gen_par%debug1) write(0,*)'No Slow file'
     !}
  end if
  if(gen_par%debug1) write(0,*)'slow_file=',slow_par%slow_file

  if (auxin('Slow_shear') .gt. 0) then
     !{
     slow_par%slow_shear_file=SLOW_INPUT
     call from_param('shear_receiver',slow_par%shear_receiver,.true.)

     call from_aux('Slow_shear',"esize",esize)

     call from_aux('Slow_shear',"n1",n_mx_slow)
     call to_history("From Slow_shear: n1",n_mx_slow)
     call from_aux('Slow_shear',"o1",mx_slow_0)
     call to_history("From Slow_shear: o1",mx_slow_0)
     call from_aux('Slow_shear',"d1",d_mx_slow)
     call to_history("From Slow_shear: d1",d_mx_slow)

     call from_aux('Slow_shear',"n2",n_my_slow)
     call to_history("From Slow_shear: n2",n_my_slow)
     call from_aux('Slow_shear',"o2",my_slow_0)
     call to_history("From Slow_shear: o2",my_slow_0)
     call from_aux('Slow_shear',"d2",d_my_slow)
     call to_history("From Slow_shear: d2",d_my_slow)

     call from_aux('Slow_shear',"n3",n_z_slow,1)
     call to_history("From Slow_shear: n3",n_z_slow)
     call from_aux('Slow_shear',"o3",z_slow_0,0.)
     call to_history("From Slow_shear: o3",z_slow_0)
     call from_aux('Slow_shear',"d3",d_z_slow,1.)
     call to_history("From Slow_shear: d3",d_z_slow)

     if(esize /= slow_par%esize_slow) call seperr('Slow_shear must be real')
     if(n_mx_slow /= slow_par%n_mx_slow) call seperr('n1 in Slow_shear /= Slow')
     if(mx_slow_0 /= slow_par%mx_slow_0) call seperr('o1 in Slow_shear /= Slow')
     if(d_mx_slow /= slow_par%d_mx_slow) call seperr('d1 in Slow_shear /= Slow')

     if(n_my_slow /= slow_par%n_my_slow) call seperr('n2 in Slow_shear /= Slow')
     if(my_slow_0 /= slow_par%my_slow_0) call seperr('o2 in Slow_shear /= Slow')
     if(d_my_slow /= slow_par%d_my_slow) call seperr('d2 in Slow_shear /= Slow')

     if(n_z_slow /= slow_par%n_z_slow) call seperr('n3 in Slow_shear /= Slow')
     if(z_slow_0 /= slow_par%z_slow_0) call seperr('o3 in Slow_shear /= Slow')
     if(d_z_slow /= slow_par%d_z_slow) call seperr('d3 in Slow_shear /= Slow')

     !}
  else 
     !{
     slow_par%slow_shear_file=SLOW_NO_FILE
     if(gen_par%debug1) write(0,*)'No Slow_shear file'
     !}
  end if
  if(gen_par%debug1) write(0,*)'slow_shear_file=',slow_par%slow_shear_file

  if (gen_par%oper_type(1:1) == 'd') then
     !{
     if (gen_par%first_adj) then
        !{
        if(slow_par%slow_file == SLOW_NO_FILE)  then
           call from_param('n_mx_slow',slow_par%n_mx_slow,image_par%n_mx_image)
!           call to_history('n_mx_slow',slow_par%n_mx_slow)
           call from_param('mx_slow_0',slow_par%mx_slow_0,data_par%mx_0_pad)
!           call to_history('mx_slow_0',slow_par%mx_slow_0)
           call from_param('d_mx_slow',slow_par%d_mx_slow,data_par%d_mx)
!           call to_history('d_mx_slow',slow_par%d_mx_slow)
           call from_param('n_my_slow',slow_par%n_my_slow,image_par%n_my_image)
!           call to_history('n_my_slow',slow_par%n_my_slow)
           call from_param('my_slow_0',slow_par%my_slow_0,data_par%my_0_pad)
!           call to_history('my_slow_0',slow_par%my_slow_0)
           call from_param('d_my_slow',slow_par%d_my_slow,data_par%d_my)
!           call to_history('d_my_slow',slow_par%d_my_slow)

           call from_param('n_z_slow',slow_par%n_z_slow,image_par%n_z_image)
!           call to_history('n_z_slow',slow_par%n_z_slow)
           call from_param('z_slow_0',slow_par%z_slow_0,image_par%z_image_0)
!           call to_history('z_slow_0',slow_par%z_slow_0)
           call from_param('d_z_slow',slow_par%d_z_slow,image_par%d_z_image)
!           call to_history('d_z_slow',slow_par%d_z_slow)
        end if

        slow_par%dslow_file=SLOW_OUTPUT
        ierr=auxinout('Dslow')
        call to_history("esize",slow_par%esize_dslow,'Dslow')
        call to_history("n1",slow_par%n_mx_slow,'Dslow')
        call to_history("o1",slow_par%mx_slow_0,'Dslow')
        call to_history("d1",slow_par%d_mx_slow,'Dslow')

        call to_history("n2",slow_par%n_my_slow,'Dslow')
        call to_history("o2",slow_par%my_slow_0,'Dslow')
        call to_history("d2",slow_par%d_my_slow,'Dslow')

        call to_history("n3",slow_par%n_z_slow,'Dslow')
        call to_history("o3",slow_par%z_slow_0,'Dslow')
        call to_history("d3",slow_par%d_z_slow,'Dslow')
        !}
     else
        !{
        if (auxinout('Dslow') > 0) then
           !{
           slow_par%dslow_file=SLOW_INPUT
           call from_aux('Dslow',"esize",esize)
           call from_aux('Dslow',"n1",slow_par%n_mx_slow)
           call from_aux('Dslow',"o1",slow_par%mx_slow_0)
           call from_aux('Dslow',"d1",slow_par%d_mx_slow)

           call from_aux('Dslow',"n2",slow_par%n_my_slow)
           call from_aux('Dslow',"o2",slow_par%my_slow_0)
           call from_aux('Dslow',"d2",slow_par%d_my_slow)

           call from_aux('Dslow',"n3",slow_par%n_z_slow,1)
           call from_aux('Dslow',"o3",slow_par%z_slow_0)
           call from_aux('Dslow',"d3",slow_par%d_z_slow)

           if(esize /= slow_par%esize_dslow) call seperr('Dslow must be complex')
           if(slow_par%z_slow_0 .gt. gen_par%z_image_0) then
              call seperr('z_slow_0 > gen_par%z_image_0 ')
           end if

           if(amod(slow_par%d_z_slow,image_par%d_z_image) .ne. 0.) then
              write(0,*)'d_z_image=',image_par%d_z_image
              write(0,*)'d_z_slow=',slow_par%d_z_slow
              call seperr('d_z_slow not multiple of d_z_image ')
           end if
           if(abs(amod(down_par%n_z_block*image_par%d_z_image, &
                                                 slow_par%d_z_slow)) > &
                   epsilon(slow_par%d_z_slow)*10.*down_par%n_z_block) then
              write(0,*)'d_z_image=',image_par%d_z_image
              write(0,*)'d_z_slow=',slow_par%d_z_slow
              call seperr('down-n_z_block*image-d_z_image not multiple slow-d_z_slow')
           end if
           !}
        else 
           !{
           slow_par%dslow_file=SLOW_NO_FILE
           call seperr ('No Dslow file')
           !}
        end if
        !}
     end if
     !}
  end if
  if(gen_par%debug1) write(0,*)'dslow_file=',slow_par%dslow_file

  ! Check parameters
  if((gen_par%freq_min_0 == freq_min_0_init).and. &
  (gen_par%freq_min_1 == freq_min_1_init).and. &
  (gen_par%freq_max_0 == freq_max_0_init).and. &
  (gen_par%freq_max_0 == freq_max_0_init)) then
     !{
     down_par%filter_data=.false.
     down_par%n_w_extrap=data_par%n_w
     if(mod(down_par%n_w_extrap,gen_par%n_w_block) .ne. 0) then
        write(0,*)'down_par-n_w_extrap=',down_par%n_w_extrap
        write(0,*)'gen_par-n_w_block=',gen_par%n_w_block
        call seperr("Param: n_w_extrap not multiple of n_w_block")
     end if
     down_par%w_min_0=data_par%w_0
     down_par%w_min_1=down_par%w_min_0
     down_par%w_max_1=data_par%w_0 + (data_par%n_w-1)*data_par%d_w
     down_par%w_max_0=down_par%w_max_1
     if(gen_par%debug1)  write(0,*)'down_par%w_min_0=',down_par%w_min_0
     if(gen_par%debug1)  write(0,*)'down_par%w_min_1=',down_par%w_min_1
     if(gen_par%debug1)  write(0,*)'down_par%w_max_0=',down_par%w_max_0
     if(gen_par%debug1)  write(0,*)'down_par%w_max_1=',down_par%w_max_1
     call to_history('n_w_extrap',down_par%n_w_extrap)
     int_nint_w_min_0=0
     !}
  else
     !{
     down_par%filter_data=.true.

     down_par%w_min_0=2.*pi*gen_par%freq_min_0
     down_par%w_min_1=2.*pi*gen_par%freq_min_1
     down_par%w_max_0=2.*pi*gen_par%freq_max_0
     down_par%w_max_1=2.*pi*gen_par%freq_max_1
     if(gen_par%debug1)  write(0,*)'data_par%d_w=',data_par%d_w
     if(gen_par%debug1)  write(0,*)'down_par%w_min_0=',down_par%w_min_0
     if(gen_par%debug1)  write(0,*)'down_par%w_min_1=',down_par%w_min_1
     if(gen_par%debug1)  write(0,*)'down_par%w_max_0=',down_par%w_max_0
     if(gen_par%debug1)  write(0,*)'down_par%w_max_1=',down_par%w_max_1

     nint_w_min_0=float(nint(down_par%w_min_0/data_par%d_w))*data_par%d_w
     int_nint_w_min_0=int(nint_w_min_0/data_par%d_w)
     if(gen_par%debug1)  write(0,*)'nint_w_min_0=',nint_w_min_0
     if(gen_par%debug1)  write(0,*)'int_nint_w_min_0=',int_nint_w_min_0
     i_w_min_0=nint(((down_par%w_min_0-nint_w_min_0)/data_par%d_w+1))
     i_w_max_0=nint(((down_par%w_max_0-nint_w_min_0)/data_par%d_w+1))
     i_w_min_1=nint(((down_par%w_min_1-nint_w_min_0)/data_par%d_w+1))
     i_w_max_1=nint(((down_par%w_max_1-nint_w_min_0)/data_par%d_w+1))
     down_par%w_min_0=nint_w_min_0+(i_w_min_0-1)*data_par%d_w
     down_par%w_max_0=nint_w_min_0+(i_w_max_0-1)*data_par%d_w
     down_par%w_min_1=nint_w_min_0+(i_w_min_1-1)*data_par%d_w
     down_par%w_max_1=nint_w_min_0+(i_w_max_1-1)*data_par%d_w
     
     down_par%n_w_extrap=min(data_par%n_w,(i_w_max_0-i_w_min_0+1))
     if(mod(down_par%n_w_extrap,gen_par%n_w_block) .ne. 0) then
        write(0,*)'n_w',data_par%n_w
        write(0,*)'nint_w_min_0=',nint_w_min_0
        write(0,*)'down_par%n_w_extrap=',down_par%n_w_extrap
        write(0,*)'down_par%w_min_0=',down_par%w_min_0
        write(0,*)'i_w_min_0=',i_w_min_0
        write(0,*)'i_w_max_0=',i_w_max_0
        write(0,*)'i_w_min_1=',i_w_min_1
        write(0,*)'i_w_max_1=',i_w_max_1
        write(0,*)'down_par-n_w_extrap=',down_par%n_w_extrap
        write(0,*)'gen_par-n_w_block=',gen_par%n_w_block
        call seperr("param_gendown: n_w_extrap not multiple of n_w_block")
     end if
     if(i_w_min_1 < i_w_min_0) call seperr('freq_min_1 not > freq_min_0')
     if(i_w_max_0 < i_w_max_1) call seperr('freq_max_0 not > freq_max_1')
     if(i_w_max_1 < i_w_min_1) call seperr('freq_max_1 not > freq_min_1')
     call to_history('n_w_extrap',down_par%n_w_extrap)
     !}
  end if
  if(gen_par%debug1) write(0,*)'filter_data=',down_par%filter_data

  ! putch right number of frequencies if needed
  if(data_par%data_file == DATA_OUTPUT) then
     if(gen_par%n_data_dim >4) then  
        call to_history("n5",down_par%n_w_extrap+int_nint_w_min_0,'Data')
     else
        call to_history("n4",down_par%n_w_extrap+int_nint_w_min_0,'Data')
     end if
  end if
  if(data_par%down_data_file == DATA_OUTPUT) then
     if(gen_par%n_data_dim >4) then  
        call to_history("n5",down_par%n_w_extrap+int_nint_w_min_0,'Down_data')
     else
        call to_history("n4",down_par%n_w_extrap+int_nint_w_min_0,'Down_data')
     end if
  end if
  if(data_par%down_ddata_file == DATA_OUTPUT) then
     if(gen_par%n_data_dim >4) then  
        call to_history("n5",down_par%n_w_extrap+int_nint_w_min_0,'Down_ddata')
     else
        call to_history("n4",down_par%n_w_extrap+int_nint_w_min_0,'Down_ddata')
     end if
  end if
  if(data_par%wavefield_file == DATA_OUTPUT) then
     if(gen_par%n_data_dim >4) then  
        call to_history("n5",down_par%n_w_extrap+int_nint_w_min_0,'Wavefield')
     else
        call to_history("n4",down_par%n_w_extrap+int_nint_w_min_0,'Wavefield')
     end if
  end if


  ! check consinstency
  select case (gen_par%domain_range(1:9))
  case ('data_imag')
  case ('data_wave')
  case ('slow_imag')
  case ('dslow_dim')
     if (gen_par%oper_type(1:1) /= 'd') then
        call seperr('ERROR: domain_range=dslow_dim and oper_type(1:1) /= d')
     end if
  case default
     write(0,*)'gen_par-domain_range=',trim(gen_par%domain_range)
     call seperr('Not supported domain_range')
  end select

  select case (gen_par%oper_type(1:2))
  case ('co')
     gen_par%oper_type(1:10)='const_slow'
     if (slow_par%slow_file /= SLOW_NO_FILE) then
        write(0,*)'WARNING: Does not need a Slow file'
        !      call seperr('Does not need a Slow file')
     end if
     if (slow_par%dslow_file /= SLOW_NO_FILE) then 
        call seperr('Does not need a Dslow file')
     end if
     if (data_par%wavefield_file == DATA_INPUT) then
        call seperr('It should not try to read Wavefield file')
     end if
  case ('ba')
     gen_par%oper_type(1:9)='back_slow'
     write(0,*)'WARNING: The oper_type=back_slow option is now deprecated.'
     write(0,*)'Use oper_type=full_slow'
     gen_par%oper_type(1:9)='full_slow'
     if (slow_par%slow_file /= SLOW_INPUT) call seperr('Need Slow file')
     if (data_par%wavefield_file == DATA_INPUT) then
        call seperr('It should not try to read Wavefield file')
     end if
  case ('fu')
     gen_par%oper_type(1:9)='full_slow'
     if (slow_par%slow_file /= SLOW_INPUT) call seperr('Need Slow file')
     if (data_par%wavefield_file == DATA_INPUT) then
        call seperr ('It should not try to read Wavefield file')
     end if
  case ('dc')
     gen_par%oper_type(1:11)='dconst_slow'
     if (slow_par%slow_file /= SLOW_NO_FILE) then
        write(0,*)'WARNING: Does not need a Slow file'
        !      call seperr('Does not need a Slow file')
     end if
     if ((image_par%image_file == IMAGE_NO_FILE) .and. &
     (data_par%data_file == DATA_NO_FILE)) then
        call seperr('Need either Image or Data file')
     end if
     if ((image_par%dimage_file == IMAGE_NO_FILE) .and. &
     (data_par%ddata_file == DATA_NO_FILE)) then
        call seperr('Need either Dimage or Ddata file')
     end if
     if (slow_par%dslow_file == SLOW_NO_FILE) call seperr('Need Dslow file')
     if (data_par%wavefield_file == DATA_OUTPUT) then
        call seperr('It should not try to write Wavefield file')
     end if
  case ('df')
     gen_par%oper_type(1:10)='dfull_slow'
     if (slow_par%slow_file == SLOW_NO_FILE) then
        call seperr('Need a Slow file')
     end if
     if ((image_par%image_file == IMAGE_NO_FILE) .and. &
     (data_par%data_file == DATA_NO_FILE)) then
        call seperr('Need either Image or Data file')
     end if
     if ((image_par%dimage_file == IMAGE_NO_FILE) .and. &
     (data_par%ddata_file == DATA_NO_FILE)) then
        call seperr('Need either Dimage or Ddata file')
     end if
     if (slow_par%dslow_file == SLOW_NO_FILE) call seperr('Need Dslow file')
     if (data_par%wavefield_file == DATA_OUTPUT) then
        call seperr('It should not try to write Wavefield file')
     end if
  case default
     write(0,*)'gen_par-oper_type=',trim(gen_par%oper_type)
     call seperr('Not supported oper_type')
  end select
  return
end subroutine param_down

subroutine param_restart(gen_par,down_par,restart_par)
  use gendown3d_types
  use down_process_types
  use restart_types
  use sep

  type (gendown3d_param_type) gen_par
  type (down_process_param_type) down_par
  type (restart_param_type) restart_par

  integer finished


   call from_param('restart',restart_par%restart,.false.)
   if(gen_par%verb) write(0,*)'restart_par-restart=',restart_par%restart

   restart_par%n_block_w=down_par%n_w_extrap/gen_par%n_w_block
   restart_par%n_block_z=down_par%n_z_down/down_par%n_z_block
   restart_par%n_total=restart_par%n_block_w*restart_par%n_block_z
   if(gen_par%verb) write(0,*)'restart_par-n_total=',restart_par%n_total

   if (restart_par%restart) then
     call from_param('finished',finished,0)
     if(restart_par%n_total == finished) restart_par%nothing_to_do=.true.
     restart_par%i_block_w=floor(float(finished)/restart_par%n_block_z)+1
     restart_par%i_block_z=mod(finished,restart_par%n_block_z)+1
     if(gen_par%verb) write(0,*)'restart_par-i_block_w=',restart_par%i_block_w
     if(gen_par%verb) write(0,*)'restart_par-i_block_z=',restart_par%i_block_z
     restart_par%i_total=finished
   else
     restart_par%i_block_w=1
     restart_par%i_block_z=0
     restart_par%i_total=0
   end if
! for backward compatibility
   if(gen_par%i_block_z_restart /= i_block_z_restart_init) then
     restart_par%restart=.true.
     restart_par%i_block_z=gen_par%i_block_z_restart 
     restart_par%i_block_w=1
     if(gen_par%verb) write(0,*)'back comp:restart_par-i_block_w=',restart_par%i_block_w
     if(gen_par%verb) write(0,*)'back comp:restart_par-i_block_z=',restart_par%i_block_z
   end if

   call sep_prog_stat("Gendown",restart_par%i_total,restart_par%n_total,1)

end subroutine param_restart

subroutine param_bound(gen_par,bound_par)
  use gendown3d_types
  use bound_types
  use sep

  type (gendown3d_param_type) gen_par
  type (bound_param_type) bound_par

  call from_param('n_mx_bound',bound_par%n_mx_bound,0)
  call from_param('n_my_bound',bound_par%n_my_bound,0)
  call from_param('n_hx_bound',bound_par%n_hx_bound,0)
  call from_param('n_hy_bound',bound_par%n_hy_bound,0)

  call from_param('mx_bound_stdev',bound_par%mx_bound_stdev,0.)
  call from_param('my_bound_stdev',bound_par%my_bound_stdev,0.)
  call from_param('hx_bound_stdev',bound_par%hx_bound_stdev,0.)
  call from_param('hy_bound_stdev',bound_par%hy_bound_stdev,0.)

  call from_param('mx_bound_min',bound_par%mx_bound_min,0.)
  call from_param('my_bound_min',bound_par%my_bound_min,0.)
  call from_param('hx_bound_min',bound_par%hx_bound_min,0.)
  call from_param('hy_bound_min',bound_par%hy_bound_min,0.)

  bound_par%bound_mx=(bound_par%n_mx_bound /= 0)
  bound_par%bound_my=(bound_par%n_my_bound /= 0)
  bound_par%bound_hx=(bound_par%n_hx_bound /= 0)
  bound_par%bound_hy=(bound_par%n_hy_bound /= 0)

  if(gen_par%debug2) write(0,*)'bound_mx',bound_par%bound_mx
  if(gen_par%debug2) write(0,*)'bound_my',bound_par%bound_my
  if(gen_par%debug2) write(0,*)'bound_hx',bound_par%bound_hx
  if(gen_par%debug2) write(0,*)'bound_hy',bound_par%bound_hy

  bound_par%bound_any= bound_par%bound_mx .or. bound_par%bound_my .or. &
                       bound_par%bound_hx .or. bound_par%bound_hy
  if(gen_par%debug2) write(0,*)'bound_any',bound_par%bound_any

  gen_par%apply_bound=bound_par%bound_any
  if(gen_par%debug2) write(0,*)'apply_bound',gen_par%apply_bound

end subroutine param_bound
