program Mute
  use sep
  implicit none

!-------------------------------------

  integer                                 :: n1, n2, n3, n4, n1v, n2v, n3v
  integer                                 :: i1, i2, i3, i4
  real					  :: o1, o2, o3, o4, o1v, o2v, o3v
  real					  :: d1, d2, d3, d4, d1v, d2v, d3v
  real                                    :: CMP
  real                                    :: rho, velocity0, amax 
  integer                                 :: CMPv,amaxv
  real, dimension(:,:,:,:), allocatable   :: adcig_in
  real, dimension(:,:,:), allocatable     :: velocity

 !-------------------------------------
 
  call sep_init()               ! Initialize I/O module, "sep".

  call from_history( n1, n2, n3, n4)
  call from_history( "o2", o2)
  call from_history( "d2", d2)
  call from_history( "o4", o4)
  call from_history( "d4", d4)
  

  !call from_history( d1)

  call from_aux( "velocity", "n1", n1v)
  call from_aux( "velocity", "o1", o1v)
  call from_aux( "velocity", "d1", d1v)
  call from_aux( "velocity", "n2", n2v)
  call from_aux( "velocity", "n3", n3v)
  
  call sep_close()

  write(0,*) "n1: ", n1
  write(0,*) "n2: ", n2
  write(0,*) "n3: ", n3
  write(0,*) "n4: ", n4

  write(0,*) "o1: ", o1 
  write(0,*) "o2: ", o2

  write(0,*) "n1v: ", n1v
  write(0,*) "n2v: ", n2v
  write(0,*) "n3v: ", n3v
  
  allocate( adcig_in(n1,n2,n3,n4) )
  allocate( velocity(n1v,n2v,n3v) )

  call sep_read( adcig_in )             ! Read input data from disk. 
  call sep_read(velocity,'velocity')
  
  do i4=1,n4
     CMP=o4+(i4-1)*d4
     CMPv=(CMP-o1v)/d1v+1.5
     !write(0,*) CMPv
     
     if(CMPv .LT. 1) then
        velocity0=velocity(1,1,1)
     else if (CMPv .GT. n1v) then
        velocity0=velocity(n1v,1,1)
     else
        velocity0=velocity(CMPv,1,1)
     end if
     !write(0,*) velocity0
     
     do i1=2,n1
        rho=velocity0/velocity(CMPv,1,i1)
        !         write(0,*) 'rho :', rho
        if (rho .LT. 1) then
           amax=asind(rho)
           !             write(0,*) i1,': amax= ', amax 
           amaxv=(amax-o2)/d2+1
           !              write(0,*) i1,': amaxv= ', amaxv 
           do i2=amaxv,n2
              adcig_in(i1,i2,1,i4)=0
           end do
        end if
     end do
  end do
  
  call sep_write( adcig_in) 

  deallocate( velocity,adcig_in)

  call exit(0)

end program Mute
