!  Post3D
!
!   DESCRIPTION
!   Phase shift and split step migration plus interpolation
!
!   USAGE
!     Ph3D_MP < in.H > out.H par=par.P apply_split_step=
!
!%

program Pre2D_vti_ssf_v14

  use sep
  use gendown3d_mod

  use Pre2D_vti_ssf_types
  use Pre2D_vti_ssf_mod
  use vti_params

  implicit none


!  interface 
!     subroutine param_Pre2D_vti_ssf(Pre2D_vti_ssf_par)
!       use Pre2D_vti_ssf_types
!       type (Pre2D_vti_ssf_param_type) Pre2D_vti_ssf_par
!     end subroutine param_Pre2D_vti_ssf
!  end interface
 


  type (Pre2D_vti_ssf_param_type) Pre2D_vti_ssf_par
  logical adj,add
  logical datuming,prestack
  integer stat,getch
  external getch
  character(len=128) tag_data,tag_mod
  integer                          :: omp_get_num_threads

  call initpar()

  call sep_begin_prog()

  call from_par('datuming',datuming,.false.)
  call from_par('add',add,.false.)
  call from_par('adj',adj,.false.)


  if(datuming) then
    tag_data='Down_data'
    tag_mod='Data'

    call param_Pre2D_vti_ssf(Pre2D_vti_ssf_par)
    call init_Pre2D_vti_ssf_par(Pre2D_vti_ssf_par)
    call gendown3d_init(verb=.false.,init_down_oper=Pre2D_vti_ssf_init)

   stat=gendown3d(adj,add,tag_mod,tag_data, &
                  Pre2D_vti_ssf_down_oper,Pre2D_vti_ssf_scatter_oper)

  else
  !{

    tag_data='Image'
    tag_mod='Data'

    call param_Pre2D_vti_ssf(Pre2D_vti_ssf_par)
    call init_Pre2D_vti_ssf_par(Pre2D_vti_ssf_par)
    call gendown3d_init(verb=.false.,init_down_oper=Pre2D_vti_ssf_init)

!!$OMP PARALLEL
!!  write(0,*)'In Main: n_threads =',omp_get_num_threads()
!!$OMP END PARALLEL

   stat=gendown3d(adj,add,tag_mod,tag_data, &
                  Pre2D_vti_ssf_down_oper,Pre2D_vti_ssf_scatter_oper)
  !}
  end if
 
   call sep_end_prog()


  stop	
end program Pre2D_vti_ssf_v14
