program main
  use sep
  use vel_uni_mod

  implicit none
  integer           :: lx, iz, ix, nz, nx, nref_max
  real, allocatable :: vmodel(:,:), vmodel_out(:,:), vref(:,:)
  real              :: vmin, vmax, dv
  call initpar()
  call from_history("n1", nz)
  call from_history("n2", nx)
  call from_par("nref_max", nref_max)
  allocate(vmodel(nz, nx), vmodel_out(nz, nx))
  call sreed("in", vmodel, 4*nz*nx)
  allocate(vref(nz, nref_max))
  call vel_uni_distr(vmodel, vref)
  do iz=1, nz
     vmin=minval(vmodel(iz,:))
     vmax=maxval(vmodel(iz,:))
     dv=(vmax-vmin)/(nref_max-1)
     do ix=1, nx
        lx=max(1, min(nref_max, nint((vmodel(iz,ix)-vmin)/dv+1.)))
        vmodel_out(iz,ix)=vref(iz, lx)
     end do
  end do
  call to_history("n1", nz)
  call to_history("n2", nx)
  call srite("out", vmodel_out, 4*nz*nx)
  
end program
