module vel_uni_mod
contains
  subroutine vel_uni_distr(vmodel, vref)
    implicit none
    real    :: vmodel(:,:), vref(:,:)
    integer :: nz, nref_max, iref, iz
    real    :: vmax, vmin, dvel

    nz=size(vmodel, 1)
    nref_max=size(vref, 2)
    vref=0.0
    do iz=1, nz
       vmax=maxval(vmodel(iz,:))
       vmin=minval(vmodel(iz,:))

       if(nref_max==1)then

          vref(iz, 1)=(vmin+vmax)/2.0

       else

          dvel=(vmax-vmin)/(nref_max-1)
          do iref=1, nref_max
             vref(iz, iref)=vmin+(iref-1)*dvel
          end do

      end if
    end do

  end subroutine
end module
