!------------------------------------
program mute


use sep
implicit none
!-------------------------------------
integer					:: n1, n2, n3, n4, n1v, n2v, n3v
integer                                 :: i1, i2, i3, i4
real					:: o1, o2, o3, o4, o1v, o2v, o3v
real					:: d1, d2, d3, d4, d1v, d2v, d3v
real                                    :: CMP
real                                    :: rho, velocity0, amax 
integer                                 :: CMPv,amaxv
real, dimension(:,:,:,:), allocatable   :: adcig_in, adcig_out
real, dimension(:,:,:), allocatable     :: velocity

!--------------------------------

call sep_init()

!call from_hist( "n1", n1)
!call from_hist( "o1", o1)
!call from_hist( "d1", d1)
!call from_hist( "n2", n2)
!call from_hist( "o2", o2)
!call from_hist( "d2", d2)
!call from_hist( "n3", n3)
!call from_hist( "o3", o3)
!call from_hist( "d3", d3)
!call from_hist( "n4", n4)
!call from_hist( "o4", o4)
!call from_hist( "d4", d4)

call from_par( "n1", n1)
call from_par( "o1", o1)
call from_par( "d1", d1)
call from_par( "n2", n2)
call from_par( "o2", o2)
call from_par( "d2", d2)
call from_par( "n3", n3)
call from_par( "o3", o3)
call from_par( "d3", d3)
call from_par( "n4", n4)
call from_par( "o4", o4)
call from_par( "d4", d4)

call from_aux( "velocity", "n1", n1v)
call from_aux( "velocity", "o1", o1v)
call from_aux( "velocity", "d1", d1v)
call from_aux( "velocity", "n2", n2v)
call from_aux( "velocity", "o2", o2v)
call from_aux( "velocity", "d2", d2v)
call from_aux( "velocity", "n3", n3v)
call from_aux( "velocity", "o3", o3v)
call from_aux( "velocity", "d3", d3v)


call sep_close()

write(0,*) "n1: ", n1
write(0,*) "n2: ", n2
write(0,*) "n3: ", n3
write(0,*) "n4: ", n4

write(0,*) "n1v: ", n1v
write(0,*) "n2v: ", n2v
write(0,*) "n3v: ", n3v

allocate(adcig_in(n1,n2,n3,n4))
call sep_read(adcig_in,'adcig')
!call sreed("in",adcig_in,n1*n2*n3*n4*4)

!allocate(adcig_out(n1,n2,n3,n4))
!adcig_out=0

!call srite('out',adcig_in, n1*n2*n3*n4*4)

!allocate(velocity(n1v,n2v,n3v))
!call sep_read(velocity,'velocity')
!do i4=1,n4
!   CMP=o4+(i4-1)*d4
!   CMPv=(CMP-o1v)/d1v+1
!   write(0,*) CMP
!   if(CMPv .GT. 1) then
!      velocity0=velocity(CMPv,1,1)
!      write(0,*) velocity0
!      do i1=2,n1
!         rho=velocity0/velocity(CMPv,1,i1)
!         write(0,*) 'rho :', rho
!         if (rho .LT. 1) then
!            amax=asind(rho)
!            write(0,*) i1,': amax= ', amax 
!            amaxv=(amax-o2)/d2+1
!            write(0,*) i1,': amaxv= ', amaxv 
!            do i2=amaxv,n2
!               adcig_out(i1,i2,1,i4)=0
!               write(0,*) 0
!            end do
!         end if
!      end do
!   end if
!end do

!deallocate(adcig_in, velocity)

call sep_write(adcig_in)

end program mute

! Loop over the depth and CMP
!do i1=1,n1
   
   ! Modified velocities - i.e. the velocity we use for the migration of the dataset
!   vvm=velocity(i1);
!   vhm=vvm;
!   vnm=vvm;
   
   ! Definition of the vector of aperture angles
   
!   do ig2=1,ng2
!      gammap(ig2)=og2+dg2*(ig2-1)
!      betarp(ig2)=gammap(ig2) ! Only true for flat reflectors
!      betasp(ig2)=-gammap(ig2) ! Only true for flat reflectors
!   end do
   
   ! Computation of the different quantities used to compute the derivatives of the depth with respect to pertubations.
   
   ! Elliptical phase velocity at the different propagation angles 
   
 !  Vellbetarp=sqrt(vvm**2*cosd(betarp)**2+vhm**2*sind(betarp)**2)
  ! Vellbetasp=sqrt(vvm**2*cosd(betasp)**2+vhm**2*sind(betasp)**2)
   
   ! VTI phase velocity at the different propagation angles
   
!   Vvtibetarp=sqrt((Vellbetarp**2+sqrt(Vellbetarp**4+vvm**2*(vnm**2-vhm**2)*sind(2*betarp)**2))/2)
!   Vvtibetasp=sqrt((Vellbetasp**2+sqrt(Vellbetasp**4+vvm**2*(vnm**2-vhm**2)*sind(2*betasp)**2))/2)
   
   ! Derivative of the elliptic phase velocity with respect to the phase angle
   
 !  DVellbetarp=sind(2*betarp)/(2*Vellbetarp)*(vhm**2-vvm**2)
 !  DVellbetasp=sind(2*betasp)/(2*Vellbetasp)*(vhm**2-vvm**2)
   
   ! Derivative of the VTI phase velocity with respect to the phase angle
!   DVvtibetarp=1/(4*Vvtibetarp)*(sind(2*betarp)*(vhm**2-vvm**2)+1/sqrt(Vellbetarp**4+vvm**2*(vnm**2-vhm**2)*sind(2*betarp)**2)*(Vellbetarp**2*sind(2*betarp)*(vhm**2-vvm**2)+2*vvm**2*(vnm**2-vhm**2)*sind(2*betarp)*cosd(2*betarp)))
!   DVvtibetasp=1/(4*Vvtibetasp)*(sind(2*betasp)*(vhm**2-vvm**2)+1/sqrt(Vellbetasp**4+vvm**2*(vnm**2-vhm**2)*sind(2*betasp)**2)*(Vellbetasp**2*sind(2*betasp)*(vhm**2-vvm**2)+2*vvm**2*(vnm**2-vhm**2)*sind(2*betasp)*cosd(2*betasp)))
   
   ! Computation of the group propagation angles
!   betarg=atand((tand(betarp)+DVvtibetarp/Vvtibetarp)/(1-tand(betarp)*DVvtibetarp/Vvtibetarp))
!   betasg=atand((tand(betasp)+DVvtibetasp/Vvtibetasp)/(1-tand(betasp)*DVvtibetasp/Vvtibetasp))
   
   ! Computation of the group aperture angle
!   gammag=0.5*(betarg-betasg)
   
   ! COMPUTATION OF THE RESIDUAL MOVEOUT
   
   ! Elliptic group slowness (the input angle is the group angle)
   
!   Sellg=sqrt((1/vvm)**2*cosd(gammag)**2+(1/vhm)**2*sind(gammag)**2)
   
   ! VTI group slowness (the input angle is the group angle)
!   Svtig=sqrt((Sellg**2+sqrt(Sellg**4+(1/vvm)**2*((1/vnm)**2-(1/vhm)**2)*sind(2*gammag)**2))/2)
   
   ! Computation of the derivatives of the elliptic group slownesses (input angle is still the group angle)
   
!   DSellg1=-(1/vvm)**2*cosd(gammag)**2/Sellg
!   DSellg2=-(1/vhm)**2*sind(gammag)**2/Sellg

   ! Computation of the derivatives of the VTI group slownesses
!   DSvtig1=Sellg/(2*Svtig)*DSellg1+(2*DSellg1*Sellg**3-(1/vvm)**2*((1/vnm)**2-(1/vhm)**2)*sind(2*gammag)**2)/(4*Svtig*sqrt(Sellg**4+(1/vvm)**2*((1/vnm)**2-(1/vhm)**2)*sind(2*gammag)**2))
!   DSvtig2=Sellg/(2*Svtig)*DSellg2+(2*DSellg2*Sellg**3+(1/vvm)**2*(1/vhm)**2*sind(2*gammag)**2)/(4*Svtig*sqrt(Sellg**4+(1/vvm)**2*((1/vnm)**2-(1/vhm)**2)*sind(2*gammag)**2))
!   DSvtig3=-((1/vvm)**2*(1/vhm)**2*sind(2*gammag)**2)/(4*Svtig*sqrt(Sellg**4+(1/vvm)**2*((1/vnm)**2-(1/vhm)**2)*sind(2*gammag)**2))
   
   ! Computation of the derivative of the depth with respect to the different perturbations
!   DZ1=-1/Svtig*DSvtig1*(1+tand(gammap)*tand(gammag))-1
!   DZ2=-1/Svtig*DSvtig2*(1+tand(gammap)*tand(gammag))
!   DZ3=-1/Svtig*DSvtig3*(1+tand(gammap)*tand(gammag))
   
   ! Actual computation of the velocity spectra
   
   ! Definition of the depth: 
!   z0m=o1+(i1-1)*d1
   
!   do i2=1,n2 ! Loop over the different values of HORIZONTAL perturbations
!      drhovh=(o2+(i2-1)*d2)
      
!      do i3=1,n3 ! Loop over the different values of the NMO velocity perturbations
!         drhovn=(o3+(i3-1)*d3)

         ! Computation of the residual moveout for the different perturbation values
         
!         rmo=z0m*(DZ2*drhovh+DZ3*drhovn) ! That is a vector 
!         rmo=(rmo-o1)/d1+1.5      
         
         ! Computation of the semblance values
!         do ig2=1,ng2
!            if (i1+rmo(ig2)>0 .AND. i1+rmo(ig2)<n1+1) then
!               intvspectra(i1,i2,i3)=intvspectra(i1,i2,i3)+adcig(i1+rmo(ig2),ig2) 
!               intdenum(i1,i2,i3)=intdenum(i1,i2,i3)+adcig(i1+rmo(ig2),ig2)**2
!            end if
!         end do
!      end do
!   end do
!end do
