subroutine param_slice(slice_par)
  use slice_types
  use sep

  implicit none
  type (slice_param_type) slice_par

!  character(len=128) :: tag_name

  integer ::  omp_get_num_threads
  integer n_threads_env,n_threads_init
  integer, external :: auxpar,getch,fetch,auxin,auxinout,sreed,sseek,auxout



  n_threads_init=1

  call from_param('verb',slice_par%verb,.false.)
  call from_param('debug1',slice_par%debug1,.false.)
  call from_param('debug2',slice_par%debug2,.false.)

  call from_param('n_threads',slice_par%n_threads,n_threads_init)
  call from_param('max_memory',slice_par%max_memory,100)


  ! checking parameters
!$omp parallel
  n_threads_env=omp_get_num_threads()
!$omp end parallel
  if(slice_par%n_threads == n_threads_init) then
     slice_par%n_threads=n_threads_env
  else
     if(n_threads_env > slice_par%n_threads) then
        call omp_set_num_threads(slice_par%n_threads)
        write(0,*)'WARNING: overwriting environment variable'
        write(0,*)'slice_par-n_threads=',slice_par%n_threads
     end if
     if(n_threads_env < slice_par%n_threads) then
        write(0,*)'slice_par-n_threads=',slice_par%n_threads
        write(0,*)'OMP_NUM_THREADS=',n_threads_env
        call seperr('ERROR: Asked for more threads than the environment variable allows')
     end if
  end if


    call from_history('esize',slice_par%esize)
    if(slice_par%esize /= 4) call seperr("Input should be real")

    call from_history('n1',slice_par%n1)
    call from_history('n2',slice_par%n2)
    call from_history('n3',slice_par%n3)
    call from_history('n4',slice_par%n4,1)
    call from_history('n5',slice_par%n5,1)
    
    call from_history('d1',slice_par%d1)
    call from_history('d2',slice_par%d2)
    call from_history('d3',slice_par%d3)
    call from_history('d4',slice_par%d4,1.)
    call from_history('d5',slice_par%d5,1.)
    
    call from_history('o1',slice_par%o1)
    call from_history('o2',slice_par%o2)
    call from_history('o3',slice_par%o3)
    call from_history('o4',slice_par%o4,0.)
    call from_history('o5',slice_par%o5,0.)

    call from_aux('Slice_coord',"esize",slice_par%esize_coord)
    if(slice_par%esize_coord /= 8) call seperr("Slice_coord should be complex")

    call from_aux('Slice_coord',"n1",slice_par%n1_coord)
    call to_history("Slice_coord n1",slice_par%n1_coord)
    call from_aux('Slice_coord',"n2",slice_par%n2_coord,1)
    call to_history("Slice_coord n2",slice_par%n2_coord)
    call from_aux('Slice_coord',"n3",slice_par%n3_coord,1)
    call to_history("Slice_coord n3",slice_par%n3_coord)

!    if(slice_par%n3 /= n1_coord) then
!      call seperr ('n1_coord should be equal to n3 data')
!    end if
    if(slice_par%n4 /= slice_par%n2_coord) then
      call seperr ('n2_coord should be equal to n4 data')
    end if
    if(slice_par%n5 /= slice_par%n3_coord) then
      call seperr ('n3_coord should be equal to n5 data')
    end if

    call to_history("n1",slice_par%n2)
    call to_history("n2",slice_par%n3)
    call to_history("n3",slice_par%n4)
    call to_history("n4",slice_par%n5)

    call to_history("d1",slice_par%d2)
    call to_history("d2",slice_par%d3)
    call to_history("d3",slice_par%d4)
    call to_history("d4",slice_par%d5)

    call to_history("o1",slice_par%o2)
    call to_history("o2",slice_par%o3)
    call to_history("o3",slice_par%o4)
    call to_history("o4",slice_par%o5)
  
  return

end subroutine param_slice
