function [z_image,gamma_image]=image_cig(s_func,s_par,z_mig,mx_mig,hx_mig,dz_dhx,dz_dmx,n_iter,i_gamma_probl,i_alpha_probl,flag)

% Computes the migrated image in the angle domain from the image in the
% susurface offset domain 
  
[n_gamma,n_alpha]=size(z_mig);

for i_alpha=1:n_alpha
  for i_gamma=1:n_gamma
    z_image(i_gamma,i_alpha)=z_mig(i_gamma,i_alpha)- ...
        dz_dhx(i_gamma,i_alpha)*hx_mig(i_gamma,i_alpha);
  end
end

gamma_0=atand(dz_dhx);
  
if (n_iter == 0)
  gamma_image=gamma_0;
else
  alpha_0=atand(dz_dmx);
  
% Evaluation of the PHASE angles from the planes tangent to the
% impulse response

% Note that in the case of flat reflectors, it is not necessary to use
% this function since the PHASE angles are equal to the arctan of the
% offset dip

  for i_iter=1:n_iter
    fprintf('Compute inverse mapping at iter %d \n',i_iter);
    [gamma_image,alpha_image]=gen_ang_nomin_tan_plane(s_func,s_par,0,dz_dhx,dz_dmx,gamma_0,alpha_0,i_gamma_probl,i_alpha_probl,flag);
    gamma_0=gamma_image;
    alpha_0=alpha_image;
  end

end
