function [gamma_out,alpha_out]=match_surf_data(s_func,s_der_func,phase_match_func,s_par_in,s_par_out,gamma_in,alpha_in,aniso,fix_rays)

  
% gamma_in and alpha_in are on a regular grid
% Those are angles
[n_gamma,n_alpha]=size(gamma_in);

clear gamma_phase alpha_phase
clear gamma_match alpha_match

if(fix_rays ==1) 
  gamma_out=gamma_in;
  alpha_out=alpha_in;
else
   % Computation of the PHASE angles from the GROUP angles
  if(aniso == 1) 
    [alpha_phase,gamma_phase]=all_phase_group_ang(s_func,s_der_func, s_par_in,-1,alpha_in,gamma_in);
    
  else
      gamma_phase=gamma_in;
      alpha_phase=alpha_in;
  end
  
  % Computation of the new PHASE angles by taking into account the change
  % in the velocity model 
  for i_alpha=1:n_alpha
    for i_gamma=1:n_gamma
      beta_s_in=alpha_phase(i_gamma,i_alpha)-gamma_phase(i_gamma,i_alpha);
      beta_r_in=alpha_phase(i_gamma,i_alpha)+gamma_phase(i_gamma,i_alpha);

      beta_s_out=phase_match_func(s_func,s_par_in,s_par_out,beta_s_in,'s');
      beta_r_out=phase_match_func(s_func,s_par_in,s_par_out,beta_r_in,'r');
      
      gamma_match(i_gamma,i_alpha)=.5*(beta_r_out - beta_s_out);
      alpha_match(i_gamma,i_alpha)=.5*(beta_r_out + beta_s_out);      
    end
  end
  
  if(aniso == 1) 
    % Computation of the GROUP angles from the PHASE angles 
    [alpha_out,gamma_out]=all_phase_group_ang(s_func,s_der_func,s_par_out,1,alpha_match,gamma_match);
  else
    gamma_out=gamma_match;
    alpha_out=alpha_match;
  end

end
