function [ang_out]=phase_group_ang(s_func,s_der_func,s_par,direction,leg,ang_in)
% Computes the conversion from the group angles to the phase angles
% (propagation angles; not aperture angles...)

if(direction == -1)
  S=s_func(s_par,ang_in,'group',leg);
  dS_dang_invS=s_der_func(s_par,ang_in,'group',leg)/S;
  tan_in=tand(ang_in);
  diff=atand(dS_dang_invS);
  ang_out=ang_in+diff;

else
  S=s_func(s_par,ang_in,'phase',leg);
  dV_dang_invV=(-s_der_func(s_par,ang_in,'phase',leg)/S^2)*S;
  diff=atand(dV_dang_invV);
  ang_out=ang_in+diff;

end

