function [ang_out]=phase_match_gen(s_func,s_par_in,s_par_out,ang_in,leg)
  
  if ((s_par_in(3) ~= 0.) | (s_par_out(3) ~=0.))
    disp('Error: not tilting allowed');
  end
  
  % Computation of the slowness along the input ray
  S_in=s_func(s_par_in,ang_in,'phase',leg);
  % Horizontal slowness
  Sx_in=(sind(ang_in)*S_in);
  
  % Computation of the input velocities
  Vv_in_sq=(1./s_par_in(1))^2;
  Vh_in_sq=(1./s_par_in(2))^2;
  Vn_in_sq=(1./s_par_in(4))^2;

  % Computation of the output velocities
  Vv_out_sq=(1./s_par_out(1))^2;
  Vh_out_sq=(1./s_par_out(2))^2;
  Vn_out_sq=(1./s_par_out(4))^2;

  % Computation of the input phase velocity 
  %  V_phase_in=sqrt(Vv_in_sq/(1+(Vv_in_sq-Vh_in_sq)*Sx_in^2));
  V_phase_in=sqrt(Vv_in_sq*(1+(Vn_in_sq-Vh_in_sq))/ ...
                  (1+(Vv_in_sq-Vh_in_sq)*Sx_in^2 + Vv_in_sq*(Vn_in_sq-Vh_in_sq)*Sx_in^4));

  % Computation of the output phase velocity
  %  V_phase_out=sqrt(Vv_out_sq/(1+(Vv_out_sq-Vh_out_sq)*Sx_in^2));
  V_phase_out=sqrt(Vv_out_sq*(1+(Vn_out_sq-Vh_out_sq))/ ...
   (1+(Vv_out_sq-Vh_out_sq)*Sx_in^2 + Vv_out_sq*(Vn_out_sq-Vh_out_sq)*Sx_in^4));

  % Computation of the output propagation angle but using Snell's law
  arg=sind(ang_in)*(V_phase_out/V_phase_in);
  if (abs(arg) <=1 )
    ang_out=asind(arg);
  else
    ang_out=asind(arg);
    fprintf('problems with ang_in =%f\n',ang_in);
  end

%  fprintf('Angle difference: %4.3f\n',ang_in-ang_out);
