function [s_func,s_der_func,ds_drho_func,phase_match_func,phase_match_der_func]=slowness_func(name)

switch lower(name(1:3))
  case {'iso'}
    disp('Isotropic slowness function')
    s_func=@s_iso;
    s_der_func=@s_iso_der;
%    s_func=@s_ti;
%    s_der_func=@s_ti_der;
%    phase_match_func=@phase_match_iso;
    phase_match_func=@phase_match_gen;
    phase_match_der_func=@phase_match_der_gen;
    ds_drho_func=@ds_drho_ell;
  case {'isc'}
    disp('Isotropic converted waves slowness function')
    s_func=@s_iso_conv;
    s_der_func=@s_iso_conv_der;
    phase_match_func=@phase_match_iso_conv;
    phase_match_der_func=@phase_match_der_gen;
    ds_drho_func=@ds_drho_ell;
  case {'ell'}
    disp('Elliptic slowness function')
    s_func=@s_ell;
    s_der_func=@s_ell_der;
%    s_func=@s_ti;
%    s_der_func=@s_ti_der;
    phase_match_func=@phase_match_gen;
    phase_match_der_func=@phase_match_der_gen;
    ds_drho_func=@ds_drho_ell;
  case {'ti1'}
    disp('TI Apprx P1 slowness function')
    s_func=@s_ti;
    s_der_func=@s_ti_der;
    phase_match_func=@phase_match_gen;
    phase_match_der_func=@phase_match_der_gen;
    ds_drho_func=@ds_drho_ti1;
  otherwise 
    disp('wrong slowness function type ')
end
