!------------------------------------
program model_build


use sep
implicit none
!-------------------------------------
integer					:: n1, n2, n3, n4, n5, i1, i2, i3, i4, i5, k1, k3, k4
real 					:: alpha, pi, z0, d1, d4
real, dimension(:,:,:,:,:), allocatable :: model  


!--------------------------------

!call sep_init(SOURCE)

call sep_init()

call from_history( "n1", n1)
call from_history( "n2", n2)
call from_history( "n3", n3)
call from_history( "n4", n4)
call from_history( "n5", n5)
call from_history( "d1", d1)
call from_history( "d4", d4)
call from_param("alpha", alpha)
call from_param("k1",k1)
call from_param("k3",k3)
call from_param("k4",k4)

allocate(model(n1,n2,n3,n4,n5)) 

!Reading the data
call sreed("in", model, n1*n2*n3*n4*n5*4)
pi=3.141592653

do i1=1,n1 ! Loop over the midpoint
   i4=k4-(tan(alpha*pi/180)*(k1-i1)*d1)/d4
   if (i1==1) write(0,*) 'i1=1: i4=', i4
   if (i1==n1) write(0,*) 'i1=n1: i4=', i4
   if (i1==k1) write(0,*) 'i1=k1: i4=', i4
   if (i4>0 .AND. i4<n4) model(i1,:,k3,i4,:)=1 ! Check that the dipping reflector is entirely in the model
end do

call srite("out",model, n1*n2*n3*n4*n5*4)

deallocate(model)

end program model_build
