!------------------------------------
program test2


use sep
implicit none
!-------------------------------------
integer					:: n1, n2, n3, n4, ng, i1, i2, i3, i4, ig, j, k
real 					:: delta, epsilon, V0, rhovv, rhovh, rhovn, z0m, drhovv, drhovh, drhovn, temp
real                                    :: o1, o2, o3, o4, og, d1, d2, d3, d4, dg
real                                    :: t0, vvt, vht, vnt, vvm, vhm, vnm
real, dimension(:,:), allocatable :: adcig
real, dimension(:,:,:,:), allocatable   :: vspectra
real, dimension(:), allocatable         :: gamma, Sell, Svti, DE1, DE2, DS1, DS2, DS3, DZ1, DZ2, DZ3, rmo

!--------------------------------

call sep_init()

call from_param( "n1", n1) ! Time axis
call from_param( "o1", o1)
call from_param( "d1", d1)
call from_param( "ng", ng) ! Reflection Angle axis
call from_param( "og", og)
call from_param( "dg", dg)
call from_param( "n2", n2) ! Rhovv parameter
call from_param( "o2", o2)
call from_param( "d2", d2)
call from_param( "n3", n3) ! Rhovh parameter
call from_param( "o3", o3)
call from_param( "d3", d3)
call from_param( "n4", n4) ! Rhovn parameter
call from_param( "o4", o4)
call from_param( "d4", d4)
call from_param( "V0", V0)
call from_param( "delta", delta)
call from_param( "epsilon", epsilon)
!call from_param( "t0", t0)
call from_param( "rhovv", rhovv)
call from_param( "rhovh", rhovh)
call from_param( "rhovn", rhovn)

call sep_close()

allocate(adcig(n1,ng))

call sep_read(adcig,'adcig') ! Reading the ADCIG we are going to estimate the perturbation parameters from 

!do i1=1,n1
!   do ig=1,ng
!      temp=temp+adcig(i1,ig)
!   end do
!end do
!write(0,*) temp

allocate(vspectra(n1,n2,n3,n4)) ! Allocation of the cube of the values for t, rhovv, rhovh and rhovn
vspectra=0

vvt=V0;
vht=V0*sqrt(1+2*epsilon);
vnt=V0*sqrt(1+2*delta);
vvm=vvt*rhovv;
vhm=vht*rhovh;
vnm=vnt*rhovn;

allocate(gamma(ng))
do ig=1,ng
   gamma(ig)=og+dg*(ig-1)
end do

! Computation of the derivatives for the velocity model that was used to do the migration

allocate(Sell(ng),Svti(ng),DE1(ng),DE2(ng),DS1(ng),DS2(ng),DS3(ng),DZ1(ng),DZ2(ng),DZ3(ng), rmo(ng))
Sell=sqrt(vvm**2*cosd(gamma)**2+vhm**2*sind(gamma)**2)
Svti=sqrt((Sell**2+sqrt(Sell**4+vvm**2*(vnm**2-vhm**2)*sind(2*gamma)**2))/2)
DE1=-vvm**2*cosd(gamma)**2/Sell
DE2=-vhm**2*sind(gamma)**2/Sell
DS1=Sell/(2*Svti)*DE1+(2*DE1*Sell**3-vvm**2*(vnm**2-vhm**2)*sind(2*gamma)**2)/(4*Svti*sqrt(Sell**4+vvm**2*(vnm**2-vhm**2)*sind(2*gamma)**2))
DS2=Sell/(2*Svti)*DE2+(2*DE2*Sell**3+vvm**2*vhm**2*sind(2*gamma)**2)/(4*Svti*sqrt(Sell**4+vvm**2*(vnm**2-vhm**2)*sind(2*gamma)**2))
DS3=-(vvm**2*vhm**2*sind(2*gamma)**2)/(4*Svti*sqrt(Sell**4+vvm**2*(vnm**2-vhm**2)*sind(2*gamma)**2))
DZ1=-1/Svti*DS1*(1+tand(gamma)**2)-1
DZ2=-1/Svti*DS2*(1+tand(gamma)**2)
DZ3=-1/Svti*DS3*(1+tand(gamma)**2)

deallocate(Sell,Svti,DE1,DE2,DS1,DS2,DS3)

! Computation of the velocity spectra

!do i1=1,n1
do i1=160,200
   write(0,*) i1," out of ",n1
   z0m=o1+(i1-1)*d1
   do i2=1,n2
     drhovv=(o2+(i2-1)*d2)
      do i3=1,n3
         drhovh=(o3+(i3-1)*d3)
         do i4=1,n4
            !k=0
            drhovn=(o4+(i4-1)*d4)
            rmo=z0m*(DZ1*drhovv+DZ2*drhovh+DZ3*drhovn)
            rmo=(rmo-o1)/d1+1.5
           ! write(0,*) j
            do ig=1,ng
               if (i1+rmo(ig)>0 .AND. i1+rmo(ig)<n1+1) vspectra(i1,i2,i3,i4)=vspectra(i1,i2,i3,i4)+adcig(i1+rmo(ig),ig)
               ! write(0,*) adcig(i1+rmo(ig),ig)
               ! k=k+1
               ! write(0,*) 'k :' k
               ! vspectra(i1,i2,i3,i4)=vspectra(i1,i2,i3,i4)/k
            end do 
         end do
      end do
   end do
end do

!call srite("out",vspectra,n1*n2*n3*n4)
call sep_write(vspectra)

! write(0,*) "A"

!deallocate(adcig)
! call exit(0)

end program test2
